#<profile4xi profile = "32" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "current_process4xi.py">
#<abstract4xi abstract = "Provides the class CurrentProcess4Xi"/>
#<refer4xi reference = "DragonXi"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

#
# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'CurrentProcess4Xi',
            'init_all_current_process4xi', 'set_all_current_process4xi', 'get_all_current_process4xi', 'get_one_current_process4xi',            
            'value_current_process4xi', 'init_current_process4xi', 'get_current_process4xi', 'set_current_process4xi', 'init_inheriting_current_process4xi', 'get_inheriting_current_process4xi', 'set_inheriting_current_process4xi', 'init_authkey_current_process4xi',
            'get_authkey_current_process4xi', 'set_authkey_current_process4xi', 'init_identity_current_process4xi', 'get_identity_current_process4xi', 'set_identity_current_process4xi', 'init_name_current_process4xi', 'get_name_current_process4xi', 'set_name_current_process4xi',
            'init_counter_current_process4xi', 'get_counter_current_process4xi', 'set_counter_current_process4xi', 'init_daemonic_current_process4xi', 'get_daemonic_current_process4xi', 'set_daemonic_current_process4xi', 'init_tempdir_current_process4xi', 'get_tempdir_current_process4xi',
            'set_tempdir_current_process4xi', 'add_child_current_process4xi', 'discard_child_current_process4xi', 'get_children_current_process4xi', 'list_children_current_process4xi', 'init_manager_server_current_process4xi', 'get_manager_server_current_process4xi', 'set_manager_server_current_process4xi'] 

#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass    
try:                 # most-common ones
    import itertools
    import tempfile
    import weakref         
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.process import Process
except:
    pass
#"
#/>
     

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi

from constant_process4xi import ConstantProcess4Xi

from examine4xi import examine4xi

from finalizer4xi import clear_finalizer_registry4xi     

from is_exiting4xi import set_exiting4xi

from print4xi import print4xi

from reason_object4xi import reason_object4xi

from time4xi import time4xi   
from timeout4xi import omega2timeout4xi

from _run_after_forkers4xi import _run_after_forkers4xi     
from _run_finalizers4xi import _run_finalizers4xi
#"
#/>








# -------------------------------------------------------------------------------------------------
# Definitions
# -------------------------------------------------------------------------------------------------
#<define4xi definition = "

_exitcode_to_name = {}

for name, signum in list(signal.__dict__.items()):
    if name[:3]=='SIG' and '_' not in name:
        _exitcode_to_name[-signum] = name
#"
#/>        

# -------------------------------------------------------------------------------------------------
#<function4xi function = "active_children4xi" usage = "
#   embedded in this module
#">
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/> 
# -------------------------------------------------------------------------------------------------
def active_children4xi():
    '''
    active_children4xi returns list of process objects corresponding to live child processes
    '''
           
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    
    class2print = 'active_children4xi'
    method2print = 'active_children4xi'
    
    message2print = "{started" + "; active-children4xi-started: " + str(active_children4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
           
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    
    message2print = "{calling" + "; cleanup-calling-by-active-children4xi: " + str(_cleanup4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
            
    _cleanup4xi()

    
    message2print = "{performed" + "; cleanup-performed-by-active-children4xi: " + str(_cleanup4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
  
               
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
        
    message2print = "{returning" + "; list-children-current-process4xi-function-returning-by-active-children4xi: " + str(list_children_current_process4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      

   
    
    return list_children_current_process4xi() #dragonized
#</function4xi>



# ---------------------------------------------------------------------------------------------
#<function4xi function = "exit-function4xi" usage = "
#   util.py
#       atexit.register(_exit_function)
#   process4xi.py:
#       _bootstrap:
#            _exit_function4xi()
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# ---------------------------------------------------------------------------------------------
def _exit_function4xi():

    '''
    exits
    '''

    # -----------------------------------------------------------------------------------------    
    # (Step 1/8): OK
    # -----------------------------------------------------------------------------------------        
 
    class2print = "_exit_function4xi"
    method2print = "_exit_function4xi"
    
    message2print = "{(Step 1/8) started" + "; exit-function4xi-started: " + str(_exit_function4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    # { _exit_function4xi : _exit_function4xi ; Step 1/5 start time: 15:23:40 09/02/09 FLE Daylight Time}
    

    
    # -----------------------------------------------------------------------------------------
    # (Step 2/8): OK
    # -----------------------------------------------------------------------------------------    
    set_exiting4xi(True)        #dragonized; added here
    
    message2print = "{(Step 2/8) performed" + "; set-exiting4xi-performed-by-exit-function4xi: " + str(set_exiting4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
        
    # { _exit_function4xi : _exit_function4xi ; Step 2/5a performed: set_exiting4xi; time: 15:23:40 09/02/09 FLE Daylight Time} 
    
    # process shutting down
    # running all atexit finalizers with priority >= 0

    # { _exit_function4xi : _exit_function4xi ; Step 2/5b inform: process shutting down; time: 15:23:40 09/02/09 FLE Daylight Time} 
    # { _exit_function4xi : _exit_function4xi ; Step 2/5c inform: running finalizers ; time: 15:23:40 09/02/09 FLE Daylight Time}
        
    # -----------------------------------------------------------------------------------------
    # (Step 3/8): OK partly; no active children in tests so far
    # -----------------------------------------------------------------------------------------    
    
    _run_finalizers4xi(0)
    
    
    message2print = "{(Step 3/8) performed" + "; run-finalizers4xi-performed-by-exit-function4xi: " + str(_run_finalizers4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
       
       
    #{ _exit_function4xi : _exit_function4xi ; Step 3/5a performed: _run_finalizers4xi; time: 15:23:40 09/02/09 FLE Daylight Time} 
        
    # -----------------------------------------------------------------------------------------    
    # (Step 4/8): 
    # -----------------------------------------------------------------------------------------        
    ack2terminate = False
    nack2terminate = True
    
    try:
    
        for childprocess2xi in active_children4xi():                 #embedded one!
        
            message2print = "{(Step 4/8a) got" + "; childprocess2xi-got-by-exit-function4xi to: " + str(childprocess2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                    
            try:
                if childprocess2xi._daemonic:
                    # calling terminate() for daemon 
                    
                    message2print = "{(Step 4/8b) calling" + "; childprocess2xi-popen-terminate-calling-by-exit-function4xi: " + str(childprocess2xi._popen.terminate) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)       
                            
                    childprocess2xi._popen.terminate()
        
                    message2print = "{performed" + "; childprocess2xi-popen-terminate-performed-by-exit-function4xi: " + str(childprocess2xi._popen.terminate) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    
                    ack2terminate = True
                    
            except:
                    ack2terminate = False
                    nack2terminate = True
                    
                    message2print = "{yielded" + "; nack2terminate-yielded-by-exit-function4xi: " + str(nack2terminate)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    
                                 
    except:
        message2print = "{yielded" + "; nack2terminate-yielded-by-exit-function4xi: " + str(nack2terminate)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
                                        
    # -----------------------------------------------------------------------------------------    
    # (Step 5/8): 
    # -----------------------------------------------------------------------------------------        
    ack2join = True     #ideal case
    nack2join = False   #ideal case
    
    try:
    
            
        for childprocess2xi in active_children4xi():
        
            try:
                message2print = "{(Step 5/8a) got" + "; childprocess2xi-got-by-exit-function4xi to: " + str(childprocess2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
               
            
                # calling join() for process
                
                    
                message2print = "{(Step 5/8b) calling" + "; childprocess2xi-join-calling-by-exit-function4xi: " + str(childprocess2xi.join) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)       
                        
                childprocess2xi.join()
        
                message2print = "{performed" + "; childprocess2xi-join-performed-by-exit-function4xi: " + str(childprocess2xi.join) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                
               
                message2print = "{(Step 5/8a) got" + "; childprocess2xi-got-by-exit-function4xi to: " + str(childprocess2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                               
                
                   
            except:
                ack2join = False  
                nack2join = True                  
 
        
                message2print = "{yielded" + "; nack2join-yielded-by-exit-function4xi: " + str(nack2join)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                     
                   
    except:
        nack2join = True 
        
        message2print = "{yielded" + "; nack2join-yielded-by-exit-function4xi: " + str(nack2join)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
    
    if ((ack2join is False) or (nack2join is True)): #something went wrong

            
        message2print = "{warned" + "; nack2join-warned-by-exit-function4xi: " + " ** " + str(nack2join)  + " ** " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         

                                
    # -----------------------------------------------------------------------------------------
    # (Step 6/8): OK 
    # -----------------------------------------------------------------------------------------        
    
    # running the remaining atexit finalizers
    
    _run_finalizers4xi()

    
    message2print = "{(Step 6/8) performed" + "; run_finalizers4xi-performed-by-exit-function4xi: " + str(_run_finalizers4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
         
    # { _exit_function4xi : _exit_function4xi ; Step 4/5 performed: _run_finalizers4xi; time: 15:23:40 09/02/09 FLE Daylight Time}
     
    # ---------------------------------------------------------------------------------------------
    # (Step 7/8): OK
    # ---------------------------------------------------------------------------------------------    

    
    set_exiting4xi(False)       #dragonized; added here
    
    
    message2print = "{(Step 7/8) performed" + "; set-exiting4xi-performed-by-exit-function4xi: " + str(set_exiting4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
         
    # { _exit_function4xi : _exit_function4xi ; Step 5/5a performed: set_exiting4xi; time: 15:23:40 09/02/09 FLE Daylight Time}    
    # { _exit_function4xi : _exit_function4xi ; Step 5/5b returning time: 15:23:40 09/02/09 FLE Daylight Time}
     
    # ---------------------------------------------------------------------------------------------
    # (Step 8/8): OK
    # ---------------------------------------------------------------------------------------------    
    message2print = "{(Step 8/8) returning" + "; exit-function4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)    

           
#</function4xi>

        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "cleanup4xi" usage = "
#   _MainProcess4xi
#       start
#           _cleanup()
#"> 
#<refer4xi reference = "process.py"/>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
#
def _cleanup4xi():

    '''
    checks for processes which have finished
    '''

    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------
          
    class2print = "_cleanup4xi"
    method2print = "_cleanup4xi"

    
    message2print = "{started" + "; cleanup4xi-started: " + str(_cleanup4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
     
    
    # check for processes which have finished
    
    for childprocess2xi in list_children_current_process4xi():             # dragonized list(get_current_process4xi()._children):
    
        message2print = "{got" + "; childprocess2xi-got-by-cleanup4xi: " + str(childprocess2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                        
                
    
        if childprocess2xi._popen.poll() is not None:
        
            message2print = "{passing" + "; childprocess2xi-passing-to-discard-child-current-process4xi-by-cleanup4xi: " + str(childprocess2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
                    
            discard_child_current_process4xi(childprocess2xi)              # dragonized _current_process._children.discard(p2xi)
            
            message2print = "{performed" + "; discard-child-current-process4xi-performed-by-cleanup4xi: " + str(discard_child_current_process4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
                    


    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------                    
    message2print = "{returning" + "; cleanup4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
                  
           
#</function4xi>



# =================================================================================================
#<class4xi class = "_MainProcess4Xi" base = "object" child = "None" synopsis = "creates object representing the main process" usage = "
#
#   current_process4xi.py
#       _current_process = _MainProcess4Xi()
# 
#   process.py
#       _MainProcess(Process)
#           _current_process = _MainProcess() 
#           del _MainProcess
#"
#>
#<refer4xi reference = "process.py"/>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
class _MainProcess4Xi(object): # does NOT and can NOT inherit from Process4Xi! 
                               # therefore this class must should have the same methods as Process4Xi coded
    '''
    creates object representing the main process
    '''
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = ('run', 'start',
                 'is_alive', 'join', 'terminate',
                 'sense', 'reason', 'ace',)          
    #"
    #/>

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    _Popen = None
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-MainProcess4Xi" usage = "initializes MainProcess4Xi">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    #<note4xi note = "initializes as _MainProcess i.e. NOT as Process - no parameters"/>
    #<refer4xi reference = "_MainProcess"/>
    # ---------------------------------------------------------------------------------------------
    def __init__(self):
                
        # -----------------------------------------------------------------------------------------    
        # (Step 1/11)
        # ----------------------------------------------------------------------------------------- 
        class2print = "_MainProcess4Xi" 
        method2print = "__init__"
        
        message2print = "{(Step 1/11a) started" + "; init-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
                 
                                        
        message2print = "{(Step 1/11b) borning" + "; mainprocess2xi-of-MainProcess4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        message2print = "{(Step 1/11c) sharing" + "; Popen-sharing-by-mainprocess2xi-of-MainProcess4Xi: " + str(_MainProcess4Xi._Popen)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
                                   

        message2print = "{(Step 1/11d) inheriting" + "; object-inheriting-by-mainprocess2xi-of-MainProcess4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #      
            
        # -----------------------------------------------------------------------------------------    
        # (Step 2/11)
        # ----------------------------------------------------------------------------------------- 
                        
        self._identity = ()


        message2print = "{(Step 2/11) set" + "; identity-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._identity)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        #     
                
        # -----------------------------------------------------------------------------------------    
        # (Step 3/11)
        # -----------------------------------------------------------------------------------------                 
         
        self._daemonic = False


        message2print = "{(Step 3/11) set" + "; daemonic-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._daemonic)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #
        
        # -----------------------------------------------------------------------------------------    
        # (Step 4/11)
        # -----------------------------------------------------------------------------------------                 
         
        self._name = 'MainProcess4Xi'


        message2print = "{(Step 4/11) set" + "; name-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._name)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------    
        # (Step 5/11)
        # -----------------------------------------------------------------------------------------                 
         
        self._parent_pid = None


        message2print = "{(Step 5/11) set" + "; parent-pid-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._parent_pid)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #
        
        # -----------------------------------------------------------------------------------------    
        # (Step 6/11)
        # -----------------------------------------------------------------------------------------                 
                         
        self._popen = None

        
        message2print = "{(Step 6/11) set" + "; popen-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._popen)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #
        
        # -----------------------------------------------------------------------------------------    
        # (Step 7/11)
        # -----------------------------------------------------------------------------------------                 
         
        self._counter = itertools.count(1) 

  
        message2print = "{(Step 7/11) set" + "; counter-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._counter)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #
        
        # -----------------------------------------------------------------------------------------    
        # (Step 8/11)
        # -----------------------------------------------------------------------------------------                 
         
        self._children = set()


        message2print = "{(Step 8/11) set" + "; children-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._children)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #
        
        # -----------------------------------------------------------------------------------------    
        # (Step 9/11)
        # -----------------------------------------------------------------------------------------                 
         
           
        self._authkey = os.urandom(32)

        message2print = "{(Step 9/11) set" + "; authkey-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._authkey)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #
        
        # -----------------------------------------------------------------------------------------    
        # (Step 10/11)
        # -----------------------------------------------------------------------------------------                 
         
        self._tempdir = tempfile.mkdtemp(prefix='pymp-')                 

        message2print = "{(Step 10/11) set" + "; tempdir-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._tempdir)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #
        
        # -----------------------------------------------------------------------------------------    
        # (Step 11/11)
        # -----------------------------------------------------------------------------------------                 
        message2print = "{(Step 11/11a) inherited" + "; object-inherited-by-mainprocess2xi-of-MainProcess4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
        #
        
        message2print = "{(Step 11/11b) activated" + "; mainprocess2xi-of-MainProcess4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #
        
        message2print = "{(Step 11/11c) shared" + "; Popen-shared-by-mainprocess2xi-of-MainProcess4Xi: " + str(_MainProcess4Xi._Popen)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
                    
        message2print = "{(Step 11/11d) returning" + "; init-of-MainProcess4Xi-returning: " + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #
  
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "run-of-MainProcess4Xi" usage = "to be run in sub-process; can be overridden in sub-class">
    #<note4xi note = "tailored from Process i.e. NOT from _MainProcess"/>
    #<refer4xi reference = "process.py"/>
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def run(self):
        '''
        to be run in sub-process; can be overridden in sub-class
        '''
        
        # -------------------------------------------------------------------------------------    
        # (Step 1/3)
        # ------------------------------------------------------------------------------------- 
             
        class2print = "_MainProcess4Xi"
        method2print = "run"
        
        message2print = "{(Step 1/3) started" + "; run-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
                        
      
        # -------------------------------------------------------------------------------------    
        # (Step 2/3)
        # ------------------------------------------------------------------------------------- 
        message2print = "{(Step 2/3a) using" + "; target-of-mainprocess2xi-using-by-run-of-MainProcess4Xi: " + str(self._target)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                    
                   
        if self._target:
            try:
                             
                
                # ----------------------------------------------------------------------------- 
                #                
                # -----------------------------------------------------------------------------               
                self._target(*self._args, **self._kwargs)
        
                message2print = "{(Step 2/3b) performed" + "; target-of-mainprocess2xi-performed-by-run-of-MainProcess4Xi to: " + str(self._target)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
            except:
                message2print = "{(Step 2/3c) hit" + "; target-of-mainprocess2xi-hit-by-run-of-MainProcess4Xi: " + " *** " + str(self._target)  + " *** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
        else:
                message2print = "{(Step 2/3d) warned" + "; target-of-mainprocess2xi-warned-by-run-of-MainProcess4Xi: " + " ** " + str(self._target)  + " ** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)               
                                                     
        # -------------------------------------------------------------------------------------    
        # (Step 3/3)
        # ------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/3) returning" + "; run-of-MainProcess4Xi-returning: " + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
       
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "start-of-MainProcess4Xi" usage = "starts a child process">
    #<note4xi note = "tailored from Process i.e. NOT from _MainProcess"/>
    #<refer4xi reference = "process.py"/>    
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def start(self):
        '''
        starts a child process
        '''
        
        # -------------------------------------------------------------------------------------    
        # (Step 1/8)
        # ------------------------------------------------------------------------------------- 
        class2print = "_MainProcess4Xi"
        method2print = "start"
        
        message2print = "{(Step 1/8) started" + "; start-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   


        # -----------------------------------------------------------------------------------------    
        # (Step 2/8)
        # -----------------------------------------------------------------------------------------                 
        message2print = "{(Step 2/8a) checking" + "; popen-of-mainprocess2xi-checking-by-start-of-MainProcess4Xi: " + str(self._popen) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                
        if self._popen is None:
       
            message2print = "{(Step 2/8c) commented" + "; starting-of-process-commented-by-start-of-MainProcess4Xi: ok = process has not yet been started " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
        else:
            message2print = "{(Step 2/8b) warning" + "; start-warning-by-start-of-MainProcess4Xi: " + " ** a process is being started twice ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)     
             
                        
        # -----------------------------------------------------------------------------------------    
        # (Step 3/8)
        # -----------------------------------------------------------------------------------------                 
        message2print = "{(Step 3/8a) got" + "; parent-pid-of-mainprocess2xi-got-by-start-of-MainProcess4Xi: " + str(self._parent_pid)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)

        
        message2print = "{(Step 3/8b) got" + "; pid-from-os-got-by-start-of-MainProcess4Xi: " + str(os.getpid())  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                        
        

        if self._parent_pid == os.getpid():        

            message2print = "{(Step 3/8d) commented" + "; pid-of-process-commented-by-start-of-MainProcess4Xi: ok = process has not yet been started " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
        else:   
            message2print = "{(Step 3/8c) warning" + "; pid-warning-by-start-of-MainProcess4Xi: " + " ** starting a process object NOT created by current process ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                    
        
                                
        # -----------------------------------------------------------------------------------------    
        # (Step 4/8)
        # -----------------------------------------------------------------------------------------                 
        if get_daemonic_current_process4xi():
            
            message2print = "{(Step 4/8a) warned" + "; daemonic-warned-by-start-of-MainProcess4Xi: " + " ** daemonic process going to have children ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
        else:                        

     
            message2print = "{(Step 4/8b) accepted" + "; mainprocess2xi-accepted-by-start-of-MainProcess4Xi: " + " process is ok because it is a daemonic one, and therefore it can have children " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                            
        
        # -----------------------------------------------------------------------------------------    
        # (Step 5/8)
        # -----------------------------------------------------------------------------------------                 
        
        _cleanup4xi()
        
        message2print = "{performed" + "; cleanup4xi-performed-by-start-of-MainProcess4Xi: " + str(_cleanup4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
        
                
        # -----------------------------------------------------------------------------------------    
        # (Step 6/8)
        # -----------------------------------------------------------------------------------------                 
        message2print = "{(Step 6/8a) analyzing" + "; Popen-of-mainprocess2xi-analyzing-by-start-of-MainProcess4Xi: " + str(self._Popen) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
                
        if self._Popen is not None:
            try:
                # ---------------------------------------------------------------------------------    
                #
                # ---------------------------------------------------------------------------------                
                self._popen = self._Popen
                
                message2print = "{(Step 6/8b) set" + "; popen-of-mainprocess2xi-set-by-start-of-MainProcess4Xi to: " + str(self._popen)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
            except:
                                
                message2print = "{(Step 6/8c) hit" + "; Popen-of-mainprocess2xi-hit-by-start-of-MainProcess4Xi: " + " *** " + str(self._Popen)  + " *** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                              
                                                
                
        else:
            try:
                # ---------------------------------------------------------------------------------    
                #
                # ---------------------------------------------------------------------------------               
                message2print = "{(Step 6/8d) passing" + "; mainprocess2xi-passing-to-Popen4Xi-by-start-of-MainProcess4Xi: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)            

                self._popen = Popen4Xi(self)
                
                message2print = "{(Step 6/8e) set" + "; popen-of-mainprocess2xi-set-by-start-of-MainProcess4Xi to: " + str(self._popen)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
            except:
                                
                message2print = "{(Step 6/8f) hit" + "; Popen4Xi-hit-by-start-of-MainProcess4Xi: " + " *** " + str(Popen4Xi)  + " *** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                        
                
        
        # -----------------------------------------------------------------------------------------    
        # (Step 7/8)
        # -----------------------------------------------------------------------------------------                 
        try:        
            add_child_current_process4xi(self)
        
            message2print = "{(Step 7/8a) added; child-of-mainprocess2xi-added: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
        except:
            message2print = "{(Step 7/8b) hit" + "; add-child-current-process4xi-hit-by-start-of-MainProcess4Xi: " + " *** " + str(add_child_current_process4xi)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                            
        # -----------------------------------------------------------------------------------------    
        # (Step 8/8)
        # -----------------------------------------------------------------------------------------                 
        message2print = "{(Step 8/8) returning" + "; start-of-MainProcess4Xi-returning: " + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                      
    #</methodize4xi>
     
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "terminate-of-MainProcess4Xi" usage = "terminates process and sends SIGTERM signal or uses TerminateProcess">
    #<note4xi note = "tailored from Process i.e. NOT from _MainProcess"/>
    #<refer4xi reference = "process.py"/>    
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def terminate(self):
        '''
        MainProcess4Xi terminate method: terminates process and sends SIGTERM signal or uses TerminateProcess
        '''

        # -------------------------------------------------------------------------------------    
        # (Step 1/3)
        # ------------------------------------------------------------------------------------- 
        class2print = "_MainProcess4Xi"
        method2print = "terminate"
        
        message2print = "{(Step 1/3a) started" + "; terminate-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        if examine4xi(class2print, method2print):            
                
            # -------------------------------------------------------------------------------------    
            #
            # ------------------------------------------------------------------------------------- 
             
            message2print = "{(StepOriginal) calling" + "; Process-terminate-calling-by-terminate-of-MainProcess4Xi: " + str(Process.terminate) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)       
    
            Process.terminate(self)
            
            message2print = "{(StepOriginal) performed" + "; Process-terminate-performed-by-terminate-of-MainProcess4Xi: " + str(Process.terminate) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
        else: 
                
            # -------------------------------------------------------------------------------------    
            # (Step 2/3)
            # ------------------------------------------------------------------------------------- 
             
            try:
                
                # -------------------------------------------------------------------------------------    
                #
                # ------------------------------------------------------------------------------------- 
                        
                self._popen.terminate()
               
                message2print = "{(Step 2/3a) performed" + "; popen-terminate-of-mainprocess2xi-performed-by-terminate-of-MainProcess4Xi: " + str(self._popen.terminate) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             

            except:
                
                # -------------------------------------------------------------------------------------    
                #
                # ------------------------------------------------------------------------------------- 
               
                message2print = "{(Step 2/3b) hit" + "; popen-terminate-of-mainprocess2xi-hit-by-terminate-of-MainProcess4Xi: " + " *** " + str(self._popen.terminate)  + " *** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                    
                                           
        # -------------------------------------------------------------------------------------    
        # (Step 3/3)
        # ------------------------------------------------------------------------------------- 
                          
        message2print = "{(Step 3/3) returning" + "; terminate-of-MainProcess4Xi-returning: " + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 

    #</methodize4xi>
                
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "join-of-MainProcess4Xi" usage = "waits until child process terminates">
    #<note4xi note = "tailored from Process i.e. NOT from _MainProcess"/>
    #<refer4xi reference = "process.py"/>    
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def join(self, timeout=None):
        '''
        waits until child process terminates
        ''' 

        # -------------------------------------------------------------------------------------    
        # (Step 1/7)
        # ------------------------------------------------------------------------------------- 
        class2print = "_MainProcess4Xi"
        method2print = "join"
        
        message2print = "{(Step 1/7a) started" + "; join-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #hw: 
        
  
        timeout = omega2timeout4xi(class2print, method2print) 

        message2print = "{(Step 1/7b) set" + "; timeout-set-by-join-of-MainProcess4Xi to: " + str(timeout)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        
        if examine4xi(class2print, method2print):                
                
            # -------------------------------------------------------------------------------------    
            #
            # ------------------------------------------------------------------------------------- 
           
            message2print = "{(StepOriginal) calling" + "; Process-join-calling-by-join-of-MainProcess4Xi: " + str(Process.join) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
                
            message2print = "{(StepOriginal) passing" + "; timeout-passing-to-Process-join-by-join-of-MainProcess4Xi: " + str(timeout) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
                          
            Process.join(self, timeout)
    
            message2print = "{(StepOriginal) performed" + "; Process-join-performed-by-join-of-MainProcess4Xi: " + str(Process.join) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             

        else:
                
            # -------------------------------------------------------------------------------------    
            # (Step 2/7)
            # ------------------------------------------------------------------------------------- 
            message2print = "{(Step 2/7) analyzing" + "; parent-pid-of-mainprocess2xi-analyzing-by-join-of-MainProcess4Xi: " + str(self._parent_pid) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)        
           
            if self._parent_pid == os.getpid():
                
                # -------------------------------------------------------------------------------------    
                #(Step 3/7)
                # ------------------------------------------------------------------------------------- 
                message2print = "{(Step 3/7a) joining" + "; parent-pid-of-mainprocess2xi-joining-by-join-of-MainProcess4Xi: " + str(self._parent_pid) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
  
                message2print = "{(Step 3/7b) analyzing" + "; popen-of-mainprocess2xi-analyzing-by-join-of-MainProcess4Xi: " + str(self._popen) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                                   
                if self._popen is not None:
                
                    # ---------------------------------------------------------------------------------    
                    # (Step 4/7)
                    # --------------------------------------------------------------------------------- 
                    message2print = "{(Step 4/7a) joining" + "; popen-of-mainprocess2xi-joining-by-join-of-MainProcess4Xi: " + str(self._popen) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 

                    message2print = "{(Step 4/7b) passing" + "; timeout-passing-to-popen-wait-of-mainprocess2xi-by-join-of-MainProcess4Xi: " + str(timeout) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)            
                    
                    res2xi = self._popen.wait(timeout)

                    message2print = "{(Step 4/7c) set" + "; res2xi-set-by-join-of-MainProcess4Xi to: " + str(res2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                                    
                    if res2xi is not None:
                        message2print = "{(Step 4/7d) passing" + "; mainprocess2xi-passing-to-discard-of-current-process-by-join-of-MainProcess4Xi: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)                      
                    
                        discard_child_current_process4xi(self)
                        
                        message2print = "{(Step 4/7e) performed" + "; discard-child-current-process4xi-performed-by-join-of-MainProcess4Xi: " + str(discard_child_current_process4xi) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)             
        
                    else:
                        message2print = "{{(Step 4/7f) analyzed" + "; res2xi-analyzed-by-join-of-MainProcess4Xi: " + str(res2xi) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        
                else:
                
                    # ---------------------------------------------------------------------------------    
                    # (Step 5/7)
                    # --------------------------------------------------------------------------------- 
                      
                    message2print = "{(Step 5/7) warned" + "; popen-of-mainprocess2xi-warned-by-join-of-MainProcess4Xi: " + " ** can only join a started process ** " + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                             
        
            else:
                
                # -------------------------------------------------------------------------------------    
                # (Step 6/7)
                # ------------------------------------------------------------------------------------- 
                 
                message2print = "{(Step 6/7) warned" + "; pid-warned-by-join-of-MainProcess4Xi: " + " ** can only join a child process ** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)               
                                
                
        # -------------------------------------------------------------------------------------    
        # (Step 7/7)
        # ------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 7/7) returning" + "; join-of-MainProcess4Xi-returning: " + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #hw: 
        
                        
                        
    #</methodize4xi>
                          
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "is-alive-of-MainProcess4Xi" usage = "returns whether process is alive">
    #<note4xi note = "tailored from Process i.e. NOT from _MainProcess"/>
    #<refer4xi reference = "process.py"/>    
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def is_alive(self):
        '''
        MainProcess4Xi is_alive method: returns whether process is alive
        '''
        
        # -------------------------------------------------------------------------------------    
        # (Step 1/5) 
        # ------------------------------------------------------------------------------------- 
               
        class2print = "_MainProcess4Xi"
        method2print = "is_alive"
         
        message2print = "{(Step 1/5a) started" + "; is-alive-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        if examine4xi(class2print, method2print):           
                
            # -------------------------------------------------------------------------------------    
            #
            # ------------------------------------------------------------------------------------- 
        
            message2print = "{(StepOriginal) passing" + "; mainprocess2xi-passing-to-Process-is-alive: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
      
            message2print = "{(StepOriginal) returning" + "; Process-is-alive-returning-by-is-alive-of-MainProcess4Xi: " + str(Process.is_alive) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  

            return Process.is_alive(self)
        else:
                
            # -------------------------------------------------------------------------------------    
            # (Step 1/5)
            # ------------------------------------------------------------------------------------- 
            message2print = "{(Step 1/5a) analyzing" + "; mainprocess2xi-analyzing-by-is-alive-of-MainProcess4Xi: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)

            if self is get_current_process4xi():
            
                message2print = "{(Step 1/5b) analyzed" + "; current-process-analyzed-by-is-alive-of-MainProcess4Xi: " + str(get_current_process4xi()) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                    
                message2print = "{(Step 1/5c) returning" + "; True-returning-by-is-alive-of-MainProcess4Xi: " + str(True) + "; time: " + time4xi() + "}" 
                print4xi(class2print, method2print, message2print)    
                                    
                return True        
                

            if self._parent_pid == os.getpid():
            
                # -------------------------------------------------------------------------------------    
                # (Step 2/5)
                # -------------------------------------------------------------------------------------             
                if self._popen is None:
                    message2print = "{(Step 2/5a) got" + "; popen-of-mainprocess2xi-got-by-is-alive-of-MainProcess4Xi: " + str(self._popen)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                                    
                
                    message2print = "{(Step 2/5b) returning" + "; False-returning-by-is-alive-of-MainProcess4Xi: " + str(False) + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)    

                    return False
                    
                # -------------------------------------------------------------------------------------    
                # (Step 3/5)
                # -------------------------------------------------------------------------------------  
                                   
                message2print = "{(Step 3/5a) calling" + "; popen-poll-of-mainprocess2xi-calling-by-is-alive-of-MainProcess4Xi: " + str(self._popen.poll) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)       

                self._popen.poll()

                message2print = "{(Step 3/5b) performed" + "; popen-poll-of-mainprocess2xi-performed-by-is-alive-of-MainProcess4Xi: " + str(self._popen.poll) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                    
                # -------------------------------------------------------------------------------------    
                # (Step 4/5)
                # ------------------------------------------------------------------------------------- 
                 
                message2print = "{ (Step 4/5) returning" + "; popen-returncode-of-mainprocess2xi-returning-by-is-alive-of-MainProcess4Xi: " + str(self._popen.returncode is None) + "; time: " + time4xi() + "}" 
                print4xi(class2print, method2print, message2print)    
                                        
                
                return self._popen.returncode is None
                
                                                       
            else:
                    
                # -------------------------------------------------------------------------------------    
                # (Step 5/5)
                # ------------------------------------------------------------------------------------- 
                     
                message2print = "{(Step 5/5a) warned" + "; parent-pid-warned-by-is-alive-of-MainProcess4Xi: " + " ** the following is NOT a child process: " + str(self._parent_pid)  + " is alive test not done ** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)               
                
                message2print = "{(Step 5/5b) returning" + "; False-returning-by-is-alive-of-MainProcess4Xi: " + str(False) + "; time: " + time4xi() + "}" 
                print4xi(class2print, method2print, message2print)    

                return False
                        
    #</methodize4xi>
                


    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "name-of-MainProcess4Xi" usage = "returns process name">
    #<note4xi note = "tailored from Process i.e. NOT from _MainProcess"/>
    #<refer4xi reference = "process.py"/>    
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @property
    def name(self):
        '''
        returns process name
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
            
        class2print = "_MainProcess4Xi"
        method2print = "name"
        
        message2print = "{started" + "; name-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        
  

        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                         
        message2print = "{returning" + "; name-of-mainprocess2xi-returning-by-name-of-MainProcess4Xi: " + str(self._name) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        
        
                        
        
        return self._name
        
    #</methodize4xi>
       
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "name-of-MainProcess4Xi" usage = "sets process name">
    #<note4xi note = "tailored from Process i.e. NOT from _MainProcess"/>
    #<refer4xi reference = "process.py"/>    
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @name.setter
    def name(self, name):
        '''
        sets process name 
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
            
        class2print = "_MainProcess4Xi"
        method2print = "name"
        
        message2print = "{started" + "; name-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #hw: 
        
  
        message2print = "{passed" + "; name-passed-to-name-of-MainProcess4Xi: " + str(name) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        #hw: 
        
        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------         
        if isinstance(name, str):
            self._name = name

        else:
            self._name = str(name)

        message2print = "{set" + "; name-of-mainprocess2xi-set-by-name-of-MainProcess4Xi to: " + str(self._name)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                
                
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{returning" + "; name-of-MainProcess4Xi-returning: " + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                  
    #</methodize4xi>
     
        
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "daemon-of-MainProcess4Xi" usage = "returns whether process is a daemon">
    #<note4xi note = "tailored from Process i.e. NOT from _MainProcess"/>
    #<refer4xi reference = "process.py"/>    
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @property
    def daemon(self):
        '''
        MainProcess4Xi daemon method: returns whether process is a daemon
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
            
        class2print = "_MainProcess4Xi"
        method2print = "daemon"
        
        message2print = "{started" + "; daemon-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
       
  
        message2print = "{returning" + "; daemonic-of-mainprocess2xi-returning-by-daemon-of-MainProcess4Xi: " + str(self._daemonic) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    

        return self._daemonic
    #</methodize4xi>
            
           
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "daemon-of-MainProcess4Xi" usage = "sets process daemonic">
    #<note4xi note = "tailored from Process i.e. NOT from _MainProcess"/>
    #<refer4xi reference = "process.py"/>    
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @daemon.setter
    def daemon(self, daemonic):
        '''
        MainProcess4Xi daemon method: sets process daemonic
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
            
        class2print = "_MainProcess4Xi"
        method2print = "daemon"
        
        message2print = "{started" + "; daemon-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   

        message2print = "{passed" + "; daemonic-passed-to-daemon-of-MainProcess4Xi: " + str(daemonic) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    

        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
        if self._popen is None:
            self._daemonic = daemonic
                
            message2print = "{set" + "; daemonic-of-mainprocess2xi-set-by-daemon-of-MainProcess4Xi to: " + str(self._daemonic)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
        else:
        
            message2print = "{analyzed" + "; popen-of-mainprocess2xi-analyzed-by-daemon-of-MainProcess4Xi: " + "already started process is " + str(self._popen) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
        message2print = "{returning" + "; daemon-of-MainProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                        
        
    #</methodize4xi>
                     
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "authkey-of-MainProcess4Xi" usage = "returns authorization key">
    #<note4xi note = "tailored from Process i.e. NOT from _MainProcess"/>
    #<refer4xi reference = "process.py"/>    
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @property
    def authkey(self):
        '''
        returns authorization key
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
            
        class2print = "_MainProcess4Xi"
        method2print = "authkey"
        
        message2print = "{started" + "; authkey-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
      
        message2print = "{returning" + "; authkey-of-mainprocess2xi-returning-by-authkey-of-MainProcess4Xi: " + str(self._authkey) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        
        
        return self._authkey
    #</methodize4xi>
            
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "authkey-of-MainProcess4Xi" usage = "sets authorization key">
    #<note4xi note = "tailored from Process i.e. NOT from _MainProcess"/>
    #<refer4xi reference = "process.py"/>    
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @authkey.setter
    def authkey(self, authkey):
        '''
        MainProcess4Xi authkey method: sets authorization key
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
            
        class2print = "_MainProcess4Xi"
        method2print = "authkey"        
        
        
        message2print = "{started" + "; authkey-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   

        message2print = "{passed" + "; authkey-passed-to-authkey-of-MainProcess4Xi: " + str(authkey) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
       
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
     
        message2print = "{passing" + "; authkey-passing-to-Process-authkey-by-authkey-of-MainProcess4Xi: " + str(authkey) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #hw: 
        
                
        self._authkey = authkey    
            
        message2print = "{set" + "; authkey-of-mainprocess2xi-set-by-authkey-of-MainProcess4Xi to: " + str(self._authkey)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
         
  
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
                    
        message2print = "{returning" + "; authkey-of-MainProcess4Xi-returning: " + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #hw: 
        
                        
          
    #</methodize4xi>
         
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "exitcode-of-MainProcess4Xi" usage = "returns exit code of process or None if it has yet to stop">
    #<note4xi note = "tailored from Process i.e. NOT from _MainProcess"/>
    #<refer4xi reference = "process.py"/>    
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @property
    def exitcode(self):
        '''
        MainProcess4Xi exicode method: returns exit code of process or `None` if it has yet to stop
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
            
        class2print = "_MainProcess4Xi"
        method2print = "exitcode"
        
        message2print = "{started" + "; exitcode-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   

        message2print = "{got" + "; popen-of-mainprocess2xi-got-by-exitcode-of-MainProcess4Xi: " + str(self._popen)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
 
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
       
        if self._popen is None:
        
            message2print = "{returning" + "; popen-of-mainprocess2xi-returning-by-exitcode-of-MainProcess4Xi: " + str(self._popen) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)    

            return self._popen
        
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
 
        message2print = "{returning" + "; popen-poll-function-of-mainprocess2xi-returning-by-exitcode-of-MainProcess4Xi: " + str(self._popen.poll) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  

        return self._popen.poll()       
    #</methodize4xi>
      
               
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ident-of-MainProcess4Xi" usage = "returns indentifier (PID) of process or None if it has yet to start">
    #<note4xi note = "tailored from Process i.e. NOT from _MainProcess"/>
    #<refer4xi reference = "process.py"/>    
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @property
    def ident(self):
        '''
        returns indentifier (PID) of process or `None` if it has yet to start
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
            
        class2print = "_MainProcess4Xi"
        method2print = "ident"
        
        message2print = "{started" + "; ident-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
 
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
        if self is get_current_process():
            message2print = "{returning" + "; pid-returning-by-ident-of-MainProcess4Xi: " + str(os.getpid()) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)    

            return os.getpid()
        else:
            message2print = "{returning" + "; has-to-start-returning-by-ident-of-MainProcess4Xi: " + str(self._popen and self._popen.pid) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)    
                                
        
            return self._popen and self._popen.pid

    #</methodize4xi>
    
    pid = ident
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "repr-of-MainProcess4Xi" usage = "presentation of MainProcess4Xi">
    #<note4xi note = "tailored from Process i.e. NOT from _MainProcess"/>
    #<refer4xi reference = "process.py"/>    
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __repr__(self):
        '''
        MainProcess4Xi __repr__ method: 
        '''
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
        class2print = "_MainProcess4Xi"
        method2print = "__repr__"

        # -----------------------------------------------------------------------------------------    
        # (Step 1/9) 
        # -----------------------------------------------------------------------------------------                 
        message2print = "{(Step 1/9) started" + "; repr-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
       
        status2xi = 'unknown'

        if self is get_current_process4xi():
            # -------------------------------------------------------------------------------------    
            # (Step 2/9) 
            # -------------------------------------------------------------------------------------            

            status2xi = 'started'
            
            message2print = "{set" + "; status2xi-set-by-repr-of-MainProcess4Xi to: " + str(status2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
                            
                            
            
        elif self._parent_pid != os.getpid():
            # -------------------------------------------------------------------------------------    
            # (Step 3/9) 
            # -------------------------------------------------------------------------------------            
            
                    
            status2xi = 'unknown'
        elif self._popen is None:
            # -------------------------------------------------------------------------------------    
            # (Step 4/9) 
            # -------------------------------------------------------------------------------------            
      
            status2xi = 'initial'
            
            message2print = "{set" + "; status2xi-set-by-repr-of-MainProcess4Xi to: " + str(status2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
                 
        else:
            if self._popen.poll() is not None:
                # ---------------------------------------------------------------------------------    
                # (Step 5/9) 
                # ---------------------------------------------------------------------------------            

                status2xi = self.exitcode
            
                message2print = "{set" + "; status2xi-set-by-repr-of-MainProcess4Xi to: " + str(status2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                     
            else:
                # ---------------------------------------------------------------------------------    
                # (Step 6/9) 
                # ---------------------------------------------------------------------------------            
   
                status2xi = 'started'
            
                message2print = "{set" + "; status2xi-set-by-repr-of-MainProcess4Xi to: " + str(status2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
  
        if type(status2xi) is int:
        
            if status2xi == 0:
                # ---------------------------------------------------------------------------------    
                # (Step 7/9) 
                # ---------------------------------------------------------------------------------            

                status2xi = 'stopped'
            
                message2print = "{set" + "; status2xi-set-by-repr-of-MainProcess4Xi to: " + str(status2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                  
            else:
                # ---------------------------------------------------------------------------------    
                # (Step 8/9) 
                # ---------------------------------------------------------------------------------            
  
                status2xi = 'stopped[%s]' % _exitcode_to_name.get(status2xi, status2xi)
            
                message2print = "{set" + "; status2xi-set-by-repr-of-MainProcess4Xi to: " + str(status2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                  
        # -----------------------------------------------------------------------------------------    
        # (Step 9/9) 
        # -----------------------------------------------------------------------------------------    
        message2print = "{(Step 9/9a) returning" + "; name-of-mainprocess2xi-returning-by-repr-of-MainProcess4Xi: " + str(self._name) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        
        message2print = "{(Step 9/9b) returning" + "; status2xi-returning-by-repr-of-MainProcess4Xi: " + str(status2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        
        message2print = "{(Step 9/9c) returning" + "; daemonic-of-mainprocess2xi-returning-by-repr-of-MainProcess4Xi: " + str(self._daemonic) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                
                
        return '<%s(%s, %s%s)>' % (type(self).__name__, self._name,
                                   status2xi, self._daemonic and ' daemon' or '')        

    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "bootstrap-of-MainProcess4Xi" usage = "bootstrap">
    #<note4xi note = "tailored from Process i.e. NOT from _MainProcess"/>
    #<refer4xi reference = "process.py"/>    
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def _bootstrap(self):
        '''
        MainProcess4Xi _bootstrap method: bootstrap; defines global objects
        ''' 
        
        # -------------------------------------------------------------------------------------    
        # (Step 1/12)
        # -------------------------------------------------------------------------------------
         
        class2print = "_MainProcess4Xi"
        method2print = "_bootstrap"
        
        message2print = "{started" + "; bootstrap-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   

        exitcode2xi = 1
        
        try:
        
            # ---------------------------------------------------------------------------------    
            # (Step 2/12)
            # ---------------------------------------------------------------------------------
             
            self._children = set()
        
            message2print = "{(Step 2/12) set" + "; children-of-mainprocess2xi-set-by-bootstrap-of-MainProcess4Xi to: " + str(self._children)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
                            
                            
            
            # ---------------------------------------------------------------------------------    
            # (Step 3/12)
            # ---------------------------------------------------------------------------------
                
            self._counter = itertools.count(1)
        
            message2print = "{(Step 3/12) set" + "; counter-of-mainprocess2xi-set-by-bootstrap-of-MainProcess4Xi to: " + str(self._counter)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            
            # ---------------------------------------------------------------------------------    
            # (Step 4/12)
            # ---------------------------------------------------------------------------------
                
            if sys.stdin is not None:
                try:
                    message2print = "{(Step 4/12a) passing" + "; sys-stdin-fileno-passing-to-os-close-by-bootstrap-of-MainProcess4Xi: " + str(sys.stdin.fileno()) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)            

                    os.close(sys.stdin.fileno())
                    
                    message2print = "{(Step 4/12b) performed" + "; os-close-performed-by-bootstrap-of-MainProcess4Xi: " + str(os.close) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    
                except (OSError, ValueError):
                    
                    message2print = "{(Step 4/12c) hit" + "; os-close-hit-by-bootstrap-of-MainProcess4Xi: " + " *** " + str(os.close)  + " *** " + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                     
                                    
        
            # ---------------------------------------------------------------------------------    
            # (Step 5/12)
            # ---------------------------------------------------------------------------------
            message2print = "{(Step 5/12a) passing" + "; mainprocess2xi-passing-to-set-current-process4xi-by-bootstrap-of-MainProcess4Xi: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
                
                                        
            set_current_process4xi(self) 
            
            message2print = "{(Step 5/12b) set" + "; current-process-set-by-bootstrap-of-MainProcess4Xi to: " + str(get_current_process4xi())  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
                            
                            
            
            # ---------------------------------------------------------------------------------    
            # (Step 6/12)
            # ---------------------------------------------------------------------------------

            clear_finalizer_registry4xi()

            message2print = "{(Step 6/12) performed" + "; clear-finalizer-registry4xi-performed-by-bootstrap-of-MainProcess4Xi: " + str(clear_finalizer_registry4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
                    
            # ---------------------------------------------------------------------------------    
            # (Step 7/12)
            # ---------------------------------------------------------------------------------
                 
            _run_after_forkers4xi()
            
            message2print = "{(Step 7/12) performed" + "; run-after-forkers4xi-performed-by-bootstrap-of-MainProcess4Xi: " + str(_run_after_forkers4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
        
            # ---------------------------------------------------------------------------------    
            # (Step 8/12)
            # ---------------------------------------------------------------------------------
     
            try:
                message2print = "{(Step 8/12a) calling" + "; run-of-mainprocess2xi-calling-by-bootstrap-of-MainProcess4Xi: " + str(self.run) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)       
                
                            
                self.run()

                message2print = "{(Step 8/12b) performed" + "; run-of-mainprocess2xi-performed-by-bootstrap-of-MainProcess4Xi: " + str(self.run) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                
                exitcode2xi = 0
                
            finally:
                _exit_function4xi()
                
                message2print = "{(Step 8/12c) performed" + "; exit-function4xi-performed-by-bootstrap-of-MainProcess4Xi: " + str(_exit_function4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                
                
        except SystemExit as e:
        
            # ---------------------------------------------------------------------------------    
            # (Step 10/12)
            # ---------------------------------------------------------------------------------
             
            if not e.args:
                exitcode2xi = 1
                
                message2print = "{(Step 10/12a) set" + "; exitcode2xi-set-by-bootstrap-of-MainProcess4Xi to: " + str(exitcode2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                
                                
                
            elif type(e.args[0]) is int:
                exitcode2xi = e.args[0]
                
                message2print = "{(Step 10/12b) set" + "; exitcode2xi-set-by-bootstrap-of-MainProcess4Xi to: " + str(exitcode2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                    
                
            else:
                sys.stderr.write(e.args[0] + '\n')
                sys.stderr.flush()
                exitcode2xi = 1
                
                message2print = "{(Step 10/12c) set" + "; exitcode2xi-set-by-bootstrap-of-MainProcess4Xi to: " + str(exitcode2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                    
                
        except:
        
            # ---------------------------------------------------------------------------------    
            # (Step 11/12)
            # ---------------------------------------------------------------------------------
           
            exitcode2xi = 1
                
            message2print = "{(Step 11/12a) set" + "; exitcode2xi-set-by-bootstrap-of-MainProcess4Xi to: " + str(exitcode2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
                
            
            import traceback
            
            sys.stderr.write('_MainProcess4Xi %s:\n' % self.name)
            
            sys.stderr.flush()
            
            traceback.print_exc()

        
        # -------------------------------------------------------------------------------------    
        # (Step 12/12)
        # -------------------------------------------------------------------------------------
        message2print = "{(Step 12/12) returning" + "; exitcode2xi-returning-by-bootstrap-of-MainProcess4Xi: " + str(exitcode2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                 
        
        return exitcode2xi
        
        
        
    #</methodize4xi>
    
        
                                       
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-MainProcess4Xi" usage = "senses MainProcess4X class objects">
    #<note4xi note = "tailored from Process i.e. NOT from _MainProcess"/>
    #<refer4xi reference = "process.py"/>    
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        senses MainProcess4X class objects
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
     
        
        class2print = "_MainProcess4Xi" 
        method2print = 'sense'
        
        message2print = "{started" + "; sense-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #hw: 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
       
        message2print = "{sensing" + "; MainProcess4Xi-sensing-by-sense-of-MainProcess4Xi: " + str(_MainProcess4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #hw: 
        
                        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-MainProcess4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #hw: 
        
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['identity-of-mainprocess2xi'] = self._identity     
            kb2xi['authkey-of-mainprocess2xi'] = self._authkey           
            kb2xi['daemonic-of-mainprocess2xi'] = self._daemonic     
            kb2xi['parent-pid-of-mainprocess2xi'] = self._parent_pid     
            kb2xi['popen-of-mainprocess2xi'] = self._popen     
            kb2xi['popen-of-mainprocess2xi'] = _MainProcess4Xi._Popen
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-MainProcess4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
              
                        
        message2print = "{sensed" + "; MainProcess4Xi-sensed-by-sense-of-MainProcess4Xi: " + str(_MainProcess4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        #hw: 
        
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-MainProcess4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        #hw: 
        
                                   
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-MainProcess4Xi" usage = "reasons MainProcess4X class objects">
    #<note4xi note = "tailored from Process i.e. NOT from _MainProcess"/>
    #<refer4xi reference = "process.py"/>    
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        reasons MainProcess4X class objects
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
           
        
        class2print = '_MainProcess4Xi'
        method2print = 'reason'

        message2print = "{started" + "; reason-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #hw: 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; MainProcess4Xi-reasoning-by-reason-of-MainProcess4Xi: " + str(_MainProcess4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #hw: 
        
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-MainProcess4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #hw: 
        
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
          
        message2print = "{reasoned" + "; MainProcess4Xi-reasoned-by-reason-of-MainProcess4Xi: " + str(_MainProcess4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        #hw: 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-MainProcess4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        #hw: 
        
                        
                           
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-MainProcess4Xi" usage = "aces MainProcess4X class objects">
    #<note4xi note = "tailored from Process i.e. NOT from _MainProcess"/>
    #<refer4xi reference = "process.py"/>    
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        aces MainProcess4X class objects 
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
         
        
        
        class2print = '_MainProcess4Xi'
        method2print = 'ace'
        
        message2print = "{started" + "; ace-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        #hw: 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; MainProcess4Xi-acing-by-ace-of-MainProcess4Xi: " + str(_MainProcess4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #hw: 
        
                   
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-MainProcess4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #hw: 
        
                

        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; MainProcess4Xi-aced-by-ace-of-MainProcess4Xi: " + str(_MainProcess4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        #hw: 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-MainProcess4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        #hw: 
        
                         
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
    #</methodize4xi>
#</class4xi>

# -------------------------------------------------------------------------------------------------
# Global object                              
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global _current_process        #<--- a smart object having methods such as ._counter
                               
#"
#/>

#<set4xi setting = "
_current_process = _MainProcess4Xi()
#                               del _MainProcess4Xi <-- if deleted from Python namespace, then functions will not find it!
#"/>
#</settings4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "value-current-process4xi" usage = "
# returns the current process values
#">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------                        
def value_current_process4xi(constant):          
    '''
    value_current_process4xi returns the current process values
    '''
    global _current_process
                    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    class2print = "value_current_process4xi"
    method2print = "value_current_process4xi"
    
    message2print = "{started" + "; value-current-process4xi-started: " + str(value_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    
    message2print = "{passed" + "; constant-passed-to-value-current-process4xi: " + str(constant) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
     
    if constant == 1:
        r2xi = _current_process
    
    if constant == 2:
        r2xi = _current_process._inheriting    

    if constant == 3:
        r2xi = _current_process._authkey 
        
    if constant == 4:
        r2xi = _current_process._identity   
        
    if constant == 5:
        r2xi = _current_process._name       
               
    if constant == 6:
        r2xi = _current_process._counter      
        
    if constant == 7:
        r2xi = _current_process._daemonic      
        
    if constant == 8:
        r2xi = _current_process._tempdir
        
    if constant == 9:
        r2xi = list(_current_process._children)
        
    if constant == 10:
  
        r2xi = _current_process._manager_server 
    if (constant > 9) or (constant < 0):    
        r2xi = False
        
    message2print = "{returning" + "; r2xi-returning-by-value-current-process4xi: " + str(r2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   

    return r2xi
#</function4xi> 

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "current-process-process4xi" usage = "
# returns _current_process
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def current_process_process4xi():
    '''
    current_process_process4xi returns _current_process
    '''
    global _current_process
                
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    class2print = "current_process_process4xi"
    method2print = "current_process_process4xi"
    
    message2print = "{started" + "; current-process-process4xi-started: " + str(current_process_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    message2print = "{returning" + "; current-process-returning-by-current-process-process4xi: " + str(_current_process) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      

    return _current_process
#</function4xi> 

 
#1           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "init-current-process4xi" usage = "
#   initializes _current_process
#"> 
#<state4xi status = "ACK4tagging; ACK4hello_world4xi; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def init_current_process4xi(caller_object=None, caller_type=False):          
    # ---------------------------------------------------------------------------------------------
    # caller_object = None, if caller wants _MainProcess4Xi as _current_process, otherwise 
    #               = self of Process4Xi i.e Process object to be created becomes _current_process
     
    # caller_type = False, if caller wants _MainProcess4Xi as _current_process                      
    #               True , if caller is Process4Xi type
    # ---------------------------------------------------------------------------------------------
    '''
    init_current_process4xi initializes _current_process
    '''
    global _current_process
    
    # ---------------------------------------------------------------------------------------------    
    # (Step 1/11)
    # ---------------------------------------------------------------------------------------------   
    class2print = "init_current_process4xi"
    method2print = "init_current_process4xi"
    
    message2print = "{(Step 1/11a) started" + "; init-current-process4xi-started: " + str(init_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    #HW: { init_current_process4xi : init_current_process4xi ; (Step 1/11a) started; init-current-process4xi-started: <function init_current_process4xi at 0x029C0228>; time: 10:36:14 01/21/10 FLE Standard Time}
    
    message2print = "{(Step 1/11b) " + "passed" + "; caller-object-passed-to-init-current-process4xi: " +str(caller_object) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    #HW: { init_current_process4xi : init_current_process4xi ; (Step 1/11b) passed; caller-object-passed-to-init-current-process4xi: <current_process4xi.CurrentProcess4Xi object at 0x02ADF030>; time: 10:36:14 01/21/10
    
        
    message2print = "{(Step 1/11c) " + "passed" + "; caller-type-passed-to-init-current-process4xi: " +str(caller_type) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    #HW: { init_current_process4xi : init_current_process4xi ; (Step 1/11c) passed; caller-type-passed-to-init-current-process4xi: False; time: 10:36:14 01/21/10 FLE Standard Time}
    #      caller wanted _MainProcess4Xi as _current_process
    

    # ---------------------------------------------------------------------------------------------
    # (Step 2/11)
    # ---------------------------------------------------------------------------------------------    
    if caller_object is None:

        _current_process = _MainProcess4Xi()     
        
        message2print = "{(Step 2/11a) " + "created" + "; currentprocess-created-by-init-current-process4xi: " + str(_current_process) + " ;time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #HW: { init_current_process4xi : init_current_process4xi ; (Step 2/11b) created; current-process-created-by-init-current-process4xi: 
        #      <MainProcess4Xi(MainProcess4Xi, unknown)> ;time: 10:36:14 01/21/10 FLE Standard Time}
        
    else:            
        if caller_type is False:

            _current_process = _MainProcess4Xi()     
            
            message2print = "{(Step 2/11b) " + "created" + "; current-process-created-by-init-current-process4xi: " + str(_current_process) + " ;time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # { init_current_process4xi : init_current_process4xi ; Step 2/11b created the main _current_process: 
            #   <MainProcess4Xi(MainProcess4Xi, unknown)> time: 11:20:42 09/11/09 FLE Daylight Time}
                
        else:
            if caller_type is True:
                _current_process = caller_object
                
                message2print = "{(Step 2/11b) " + "created" + "; current-process-created-by-init-current-process4xi: " + str(_current_process) + " ;time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)       
            else:
 
                _current_process = _MainProcess4Xi()     
                
                message2print = "{(Step 2/11a) " + "created" + "; current-process-created-by-init-current-process4xi: " + str(_current_process) + " ;time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)            
                
    # ---------------------------------------------------------------------------------------------
    #NOTES: the following Steps 3....require that caller_object given as parameter is a Process4Xi type
    #       also you can NOT give any parameters
    #       and hopefully the module calling this function takes care of initializing values it needs!  
    
    # ---------------------------------------------------------------------------------------------
    # (Step 3/11)
    # ---------------------------------------------------------------------------------------------          

        
    init_identity_current_process4xi()
    
    message2print = "{(Step 3/11) initialized; identity-of-current-process-initialized-by-init-current-process4xi to: " + str(_current_process._identity) + ";time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    #HW: { init_current_process4xi : init_current_process4xi ; (Step 3/11) initialized; identity-of-current-process-initialized-by-init-current-process4xi to: ();time: 10:36:14 01/21/10 FLE Standard Time}
           
    
    # ---------------------------------------------------------------------------------------------
    # (Step 4/11)
    # ---------------------------------------------------------------------------------------------          

        
    init_daemonic_current_process4xi()

    message2print = "{(Step 4/11) initialized; daemonic-of-current-process-initialized-by-init-current-process4xi to: " + str(_current_process._daemonic) + ";time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #HW: { init_current_process4xi : init_current_process4xi ; (Step 4/11) initialized; daemonic-of-current-process-initialized-by-init-current-process4xi to: False;time: 10:36:14 01/21/10 FLE Standard Time}          
    
    # ---------------------------------------------------------------------------------------------
    # (Step 5/11)
    # ---------------------------------------------------------------------------------------------  

    init_name_current_process4xi()

    message2print = "{(Step 5/11) initialized; name-of-current-process-initialized-by-init-current-process4xi to: " + str(_current_process._name) + ";time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #HW:  init_current_process4xi : init_current_process4xi ; (Step 5/11) initialized; name-of-current-process-initialized-by-init-current-process4xi to: MainProcess4Xi;time: 10:36:14 01/21/10 FLE Standard Time}
        
    # ---------------------------------------------------------------------------------------------
    # (Step 6/11)
    # ---------------------------------------------------------------------------------------------    

    message2print = "{(Step 6/11) noting" + "; parent-pid-noting-by-init-current-process4xi: " + " parent pid setting for the current process is not the responsibility of init-current-process4xi " + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
                                               
                    
    # ---------------------------------------------------------------------------------------------
    # (Step 7/11)
    # ---------------------------------------------------------------------------------------------   

    message2print = "{(Step 7/11) noting" + "; popen-noting-by-init-current-process4xi: " + " popen setting for the current process is not the responsibility of init-current-process4xi " + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
          
    # ---------------------------------------------------------------------------------------------
    # (Step 8/11)
    # ---------------------------------------------------------------------------------------------

    init_counter_current_process4xi()     

    message2print = "{(Step 8/11a) initialized; counter-of-current-process-initialized-by-init-current-process4xi to: " + str(get_counter_current_process4xi()) + ";time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #HW: { init_current_process4xi : init_current_process4xi ; (Step 8/11a) initialized; counter-of-current-process-initialized-by-init-current-process4xi to: count(1);time: 10:36:14 01/21/10 FLE Standard Time}    
    
    # ---------------------------------------------------------------------------------------------
    # (Step 9/11)
    # ---------------------------------------------------------------------------------------------
    
    init_children_current_process4xi() 
   
    message2print = "{(Step 9/11) initialized; children-of-current-process-initialized-by-init-current-process4xi to : " + str(get_children_current_process4xi()) + ";time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
    #HW: { init_current_process4xi : init_current_process4xi ; (Step 9/11) initialized; children-of-current-process-initialized-by-init-current-process4xi to : set();time: 10:36:14 01/21/10 FLE Standard Time}
    
    # ---------------------------------------------------------------------------------------------
    # (Step 10/11)
    # ---------------------------------------------------------------------------------------------
      
    init_authkey_current_process4xi()
    
    message2print = "{(Step 10/11) initialized; authkey-of-current-process-initialized-by-init-current-process4xi to: " + str(get_authkey_current_process4xi())  + ";time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
    #HW: { init_current_process4xi : init_current_process4xi ; (Step 10/11) initialized; authkey-of-current-process-initialized-by-init-current-process4xi to: b'X\x1b].\xb14\x06\x7fW\xaf\x94\x9a\x8eT.\x03:\xc7K\xbd,\x99\x8a\x14\xcc$R\xe4\xba\x85\xf0\xbd';time: 10:36:14 01/21/10 FLE Standard Time}

    
    # ---------------------------------------------------------------------------------------------
    # (Step 11/11) 
    # ---------------------------------------------------------------------------------------------       

    init_tempdir_current_process4xi()

    message2print = "{(Step 11/11a) initialized; tempdir-of-current-process-initialized-by-init-current-process4xi to: " + str(get_tempdir_current_process4xi())  + ";time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    #HW: { init_current_process4xi : init_current_process4xi ; (Step 11/11a) initialized; tempdir-of-current-process-initialized-by-init-current-process4xi to: c:\users\ceo4dr~1\appdata\local\temp\pymp-eagcat;time: 10:36:14 01/21/10 FLE Standard Time}
    
                   
    message2print = "{returning" + "; init-current-process4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    #HW: { init_current_process4xi : init_current_process4xi ; returning; init-current-process4xi-returning: 10:36:14 01/21/10 FLE Standard Time}
    
#</function4xi> 

         
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-current-process4xi" usage = "
#   p2xi = get_current_process4xi()
#"> 
#<state4xi status = "ACK4tagging; ACK4HW; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def get_current_process4xi():          
    '''
    returns process object representing the current process
    '''
    global _current_process
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    class2print = "get_current_process4xi"
    method2print = "get_current_process4xi"
    
    message2print = "{started" + "; get-current-process4xi-started: " + str(get_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #HW: { get_current_process4xi : get_current_process4xi ; started; get-current-process4xi-started: <function get_current_process4xi at 0x029C0300>; time: 10:36:14 01/21/10 FLE Standard Time}
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------       
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-initialized-warned-by-get-current-process4xi: " + " ** _current_process  was None and got initialized " + str(_current_process) + " ** "  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       

      
           
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------       

    return _current_process    
#</function4xi> 

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set-current-process4xi" usage = "
# sets process object representing the current process
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def set_current_process4xi(caller_object=None, caller_type=False):          
    '''
    set_current_process4xi sets process object representing the current process
    '''
    global _current_process
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    class2print = "set_current_process4xi"
    method2print = "set_current_process4xi"
    
    
    message2print = "{started" + "; set-current-process4xi-started: " + str(set_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
         
    message2print = "{passed" + "; caller-object-passed-to-set-current-process4xi-by-set-current-process4xi: " + str(caller_object) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
 
         
    message2print = "{passed" + "; caller-type-passed-to-set-current-process4xi-by-set-current-process4xi: " + str(caller_type) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
         
    # ---------------------------------------------------------------------------------------------
    # assert param is None, 'current_process4xi.py: set_current_process4xi has to get a process'
    # ---------------------------------------------------------------------------------------------    
    if caller_object is None:
        init_current_process4xi()
    else:
        if caller_type is False:
            init_current_process4xi()
        else:
            if caller_type is True:    
                _current_process = caller_object #for example Process4Xi _bootstratp Step 5/12 cp2xi.init_all_current()<-- self embedded !           
            else:
                init_current_process4xi()
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    message2print = "{set" + "; current-process-set-by-set-current-process4xi to: " + str(_current_process)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                   

    message2print = "{returning" + "; set-current-process4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                 
#</function4xi> 

            
#2
# -------------------------------------------------------------------------------------------------
#<function4xi function = "init-inheriting-current-process4xi" usage = "
# initializes the inheritance of the current process
#"> 
#<state4xi status = "ACK4tagging; ACK4HW; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def init_inheriting_current_process4xi(param=True):          
    '''
    init_inheriting_current_process4xi initializes the inheritance of the current process
    '''
    global _current_process
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    class2print = "init_inheriting_current_process4xi"
    method2print = "init_inheriting_current_process4xi"
    
    
    message2print = "{started" + "; init-inheriting-current-process4xi-started: " + str(init_inheriting_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #HW: { init_inheriting_current_process4xi : init_inheriting_current_process4xi ; started; init-inheriting-current-process4xi-started: <function init_inheriting_current_process4xi at 0x029C08E8>; time: 10:36:14 01/21/10 FLE Standard Time}


    message2print = "{passed" + "; param-passed-to-init-inheriting-current-process4xi-by-init-inheriting-current-process4xi: " + str(param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    #HW: { init_inheriting_current_process4xi : init_inheriting_current_process4xi ; passed; param-passed-to-init-inheriting-current-process4xi-by-init-inheriting-current-process4xi: True; time: 10:36:14 01/21/10 FLE Standard Time}

  
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------              
    if param is None:
        param = True
    
    if _current_process is None:
        init_current_process4xi() 
 
        message2print = "{warned" + "; current-process-warned-by-init-inheriting-current-process4xi: _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        
    # make atomic; lock
    _current_process._inheriting = param            
    # release lock 

    message2print = "{initialized" + "; current-process-inheriting-initialized-by-init-inheriting-current-process4xi to: " + str(_current_process._inheriting)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    #HW: { init_inheriting_current_process4xi : init_inheriting_current_process4xi ; initialized; current-process-inheriting-initialized-by-init-inheriting-current-process4xi to: True; time: 11:17:25 01/21/10 FLE Standard Time}

            
                
        
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    message2print = "{returning" + "; init-inheriting-current-process4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    #HW: { init_inheriting_current_process4xi : init_inheriting_current_process4xi ; returning; init-inheriting-current-process4xi-returning: 11:17:25 01/21/10 FLE Standard Time}
          
#</function4xi> 

 
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-inheriting-current-process4xi" usage = "
# returns theinheritance info of the current process
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def get_inheriting_current_process4xi():          
    '''
    get_inheriting_current_process4xi returns theinheritance info of the current process
    '''
    global _current_process

    # ---------------------------------------------------------------------------------------------    
    #
    # --------------------------------------------------------------------------------------------- 
    class2print = "get_inheriting_current_process4xi"
    method2print = "get_inheriting_current_process4xi"
    
    message2print = "{started" + "; get-inheriting-current-process4xi-started: " + str(get_inheriting_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
       
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------       
    if _current_process is None:
        init_current_process4xi() 
    
        message2print = "{warned" + "; current-process-warned-by-get-inheriting-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
      
    message2print = "{returning" + "; current-process-inheriting-returning-by-get-inheriting-current-process4xi: " + str(_current_process._inheriting) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
  
    return _current_process._inheriting    
#</function4xi> 

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set-inheriting-current-process4xi" usage = "
# sets the inheritance to the current process
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def set_inheriting_current_process4xi(param=True):          
    '''
    set_inheriting_current_process4xi sets the inheritance to the current process
    '''
    global _current_process
    
    class2print = "set_inheriting_current_process4xi"
    method2print = "set_inheriting_current_process4xi" 
    
    message2print = "{started" + "; set-inheriting-current-process4xi-started: " + str(set_inheriting_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
         
    
    message2print = "{passed" + "; param-passed-to-set-inheriting-current-process4xi-by-set-inheriting-current-process4xi: " + str(param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
      
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------  
    if param is None:
        param = True
    
    if _current_process is None:
        init_current_process4xi() 
    
        message2print = "{warned" + "; current-process-warned-by-set-inheriting-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
          
    
    # make atomic; lock
    _current_process._inheriting = param            
    # release lock         
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   

    message2print = "{set; current-process-inheriting-set-by-set-inheriting-current-process4xi to: " + str(_current_process._inheriting) + ";time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    
    message2print = "{returning" + "; set-inheriting-current-process4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)       
#</function4xi> 

 
#3
# -------------------------------------------------------------------------------------------------
#<function4xi function = "init-authkey-current-process4xi" usage = "
# initializes the inheritance of the current process
#"> 
#<state4xi status = "ACK4tagging; ACK4HW; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def init_authkey_current_process4xi(param=os.urandom(32)):         
    '''
    init_authkey_current_process4xi initializes the inheritance of the current process
    '''
    global _current_process
    
    class2print = "init_authkey_current_process4xi"
    method2print = "init_authkey_current_process4xi" 
    
    message2print = "{started" + "; init-authkey-current-process4xi-started: " + str(init_authkey_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #HW: { init_authkey_current_process4xi : init_authkey_current_process4xi ; started; init-authkey-current-process4xi-started: <function init_authkey_current_process4xi at 0x02A46780>; time: 11:17:25 01/21/10 FLE Standard Time}
        
    
    message2print = "{passed" + "; param-passed-to-init-authkey-current-process4xi-by-init-authkey-current-process4xi: " + str(param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    #HW: { init_authkey_current_process4xi : init_authkey_current_process4xi ; passed; param-passed-to-init-authkey-current-process4xi-by-init-authkey-current-process4xi: b'\xf2\x19\x91\xf2\xa6C\xba\x03\r\x9b$y\x1e# QX\xf6\xcf[Co\xf7\x92\x8c\x92|h\xdf;\xabE'; time: 11:17:25 01/21/10 FLE Standard Time}

 
     
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------  

    if param is None:
        param = os.urandom(32)
    
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-init-authkey-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
     
        
    # make atomic; lock
    _current_process._authkey = param            

    message2print = "{set; current-process-authkey-set-by-init-authkey-current-process4xi to: " + str(_current_process._authkey) + ";time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)            
    #HW: { init_authkey_current_process4xi : init_authkey_current_process4xi ; set; current-process-authkey-set-by-init-authkey-current-process4xi to: b'\xf2\x19\x91\xf2\xa6C\xba\x03\r\x9b$y\x1e# QX\xf6\xcf[Co\xf7\x92\x8c\x92|h\xdf;\xabE';time: 11:17:25 01/21/10 FLE Standard Time}


    # release lock 
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   

    message2print = "{returning" + "; init-authkey-current-process4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)     
    #HW: { init_authkey_current_process4xi : init_authkey_current_process4xi ; returning; init-authkey-current-process4xi-returning: 11:17:25 01/21/10 FLE Standard Time}
    
#</function4xi> 

    
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-authkey-current-process4xi" usage = "
# returns the inheritance info of the current process
#"> 
#<state4xi status = "ACK4tagging; ACK4HW; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def get_authkey_current_process4xi():          
    '''
    get_authkey_current_process4xi returns the inheritance info of the current process
    '''
    global _current_process
    
    class2print = "get_authkey_current_process4xi"
    method2print = "get_authkey_current_process4xi"
    
    message2print = "{started" + "; get-authkey-current-process4xi-started: " + str(get_authkey_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #HW: { get_authkey_current_process4xi : get_authkey_current_process4xi ; started; get-authkey-current-process4xi-started: <function get_authkey_current_process4xi at 0x02A467C8>; time: 11:17:25 01/21/10 FLE Standard Time}

   
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
   
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-get-authkey-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
           
    

    message2print = "{returning" + "; current-process-authkey-returning-by-get-authkey-current-process4xi: " + str(_current_process._authkey) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    #HW: { get_authkey_current_process4xi : get_authkey_current_process4xi ; returning; current-process-authkey-returning-by-get-authkey-current-process4xi: b'\xf2\x19\x91\xf2\xa6C\xba\x03\r\x9b$y\x1e# QX\xf6\xcf[Co\xf7\x92\x8c\x92|h\xdf;\xabE'; time: 11:17:25 01/21/10 FLE Standard Time}


          
    return _current_process._authkey    
#</function4xi> 

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set-authkey-current-process4xi" usage = "
# sets the authorization key to the current process
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def set_authkey_current_process4xi(param=os.urandom(32)):         
    '''
    set_authkey_current_process4xi sets the authorization key to the current process
    '''
    global _current_process
    
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    class2print = "set_authkey_current_process4xi"
    method2print = "set_authkey_current_process4xi"    
    
    
    message2print = "{started" + "; set-authkey-current-process4xi-started: " + str(set_authkey_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
      
    message2print = "{passed" + "; param-passed-to-set-authkey-current-process4xi: " + str(param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
           
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------  
    if param is None:
        param = os.urandom(32)
    
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-set-authkey-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        
    
    # make atomic; lock
    _current_process._authkey = param            
    # release lock                 
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   

    message2print = "{set; current-process-authkey-set-by-set-authkey-current-process4xi to: " + str(_current_process._authkey) + ";time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  

    message2print = "{returning" + "; set-authkey-current-process4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                  
#</function4xi> 

 
#4
# -------------------------------------------------------------------------------------------------
#<function4xi function = "init-identity-current-process4xi" usage = "
#   initializes the identity of the current process
#   process object identity is initialized as follows:
#       class _MainProcess(Process):
#           __init__:
#               self._identity = ()
#"> 
#<state4xi status = "ACK4tagging; ACK4HW; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def init_identity_current_process4xi(param=()):          
    '''
    init_identity_current_process4xi initializes the identity of the current process
    '''
    global _current_process
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------  
    class2print = "init_identity_current_process4xi"
    method2print = "init_identity_current_process4xi"
    
    
    message2print = "{started" + "; init-identity-current-process4xi-started: " + str(init_identity_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #HW: { init_identity_current_process4xi : init_identity_current_process4xi ; started; init-identity-current-process4xi-started: <function init_identity_current_process4xi at 0x02A46858>; time: 11:17:25 01/21/10 FLE Standard Time}

  
    
    message2print = "{passed" + "; param-passed-to-init-identity-current-process4xi-by-init-identity-current-process4xi: " + str(param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    #HW: { init_identity_current_process4xi : init_identity_current_process4xi ; passed; param-passed-to-init-identity-current-process4xi-by-init-identity-current-process4xi: (); time: 11:17:25 01/21/10 FLE Standard Time}
         
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------  

    if param is None:
        param = ()
    
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-init-identity-current-process4xi: ** _current_process was None and got initialized ** " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
       
        
    # make atomic; lock
    _current_process._identity = param            
    # release lock 
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   

    message2print = "{set; current-process-identity-set-by-init-identity-current-process4xi to: " + str(_current_process._identity) + ";time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    #HW: { init_identity_current_process4xi : init_identity_current_process4xi ; set; current-process-identity-set-by-init-identity-current-process4xi to: ();time: 11:17:25 01/21/10 FLE Standard Time}
    
    
    message2print = "{returning" + "; init-identity-current-process4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    #HW: { init_identity_current_process4xi : init_identity_current_process4xi ; returning; init-identity-current-process4xi-returning: 11:17:25 01/21/10 FLE Standard Time}
          
#</function4xi> 

             
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-identity-current-process4xi" usage = "
# returns the identity info of the current process
#"> 
#<state4xi status = "ACK4tagging; ACK4HW; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def get_identity_current_process4xi():          
    '''
    get_identity_current_process4xi returns the identity info of the current process
    '''
    global _current_process

    class2print = "get_identity_current_process4xi"
    method2print = "get_identity_current_process4xi"        
    
    message2print = "{started" + "; get-identity-current-process4xi-started: " + str(get_identity_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #HW: { get_identity_current_process4xi : get_identity_current_process4xi ; started; get-identity-current-process4xi-started: <function get_identity_current_process4xi at 0x02A468A0>; time: 11:17:25 01/21/10 FLE Standard Time}
    
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   

    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-get-identity-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
   
    message2print = "{returning" + "; current-process-identity-returning-by-get-identity-current-process4xi: " + str(_current_process._identity) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    #HW: { get_identity_current_process4xi : get_identity_current_process4xi ; returning; current-process-identity-returning-by-get-identity-current-process4xi: (); time: 11:17:25 01/21/10 FLE Standard Time}
       
    return _current_process._identity    
#</function4xi> 

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set-identity-current-process4xi" usage = "
# sets the identity to the current process
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def set_identity_current_process4xi(param=()):           
    '''
    set_identity_current_process4xi sets the identity to the current process
    '''
    global _current_process
    
    class2print = "set_identity_current_process4xi"
    method2print = "set_identity_current_process4xi"
    
    
    message2print = "{started" + "; set-identity-current-process4xi-started: " + str(set_identity_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
      
    message2print = "{passed" + "; param-passed-to-set-identity-current-process4xi-by-set-identity-current-process4xi: " + str(param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
         
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------  

    if param is None:
        param = ()
    
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-set-identity-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
       
    
    # make atomic; lock
    _current_process._identity = param            
    # release lock                       
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   

    message2print = "{set; current-process-identity-set-by-set-identity-current-process4xi to: " + str(_current_process._identity) + ";time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{returning" + "; set-identity-current-process4x-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)             
#</function4xi> 

         
#5
# -------------------------------------------------------------------------------------------------
#<function4xi function = "init-name-current-process4xi" usage = "
# initializes the name of the current process
#"> 
#<state4xi status = "ACK4tagging; ACK4HW; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def init_name_current_process4xi(param='MainProcess4Xi'):        
    '''
    init_name_current_process4xi initializes the name of the current process
    '''
    global _current_process

    class2print = "init_name_current_process4xi"
    method2print = "init_name_current_process4xi"
    
    
    message2print = "{started" + "; init-name-current-process4xi-started: " + str(init_name_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #HW: { init_name_current_process4xi : init_name_current_process4xi ; started; init-name-current-process4xi-started: <function init_name_current_process4xi at 0x02A46930>; time: 11:17:25 01/21/10 FLE Standard Time}
      
    
    message2print = "{passed" + "; param-passed-to-init-name-current-process4xi-by-init-name-current-process4xi: " + str(param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    #HW: { init_name_current_process4xi : init_name_current_process4xi ; passed; param-passed-to-init-name-current-process4xi-by-init-name-current-process4xi: MainProcess4Xi; time: 11:17:25 01/21/10 FLE Standard Time}
     
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------  

    if param is None:
        param = 'MainProcess4Xi'
    
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-init-name-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        
        
    # make atomic; lock
    _current_process._name = param            
    # release lock 

    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   

    message2print = "{set; current-process-name-set-by-init-name-current-process4xi to: " + str(_current_process._name) + ";time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    #HW: { init_name_current_process4xi : init_name_current_process4xi ; set; current-process-name-set-by-init-name-current-process4xi to: MainProcess4Xi;time: 11:17:25 01/21/10 FLE Standard Time}
    
    message2print = "{returning" + "; init-name-current-process4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    #HW: { init_name_current_process4xi : init_name_current_process4xi ; returning; init-name-current-process4xi-returning: 11:17:25 01/21/10 FLE Standard Time}
                 
#</function4xi> 

             
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-name-current-process4xi" usage = "
# returns the name of the current process
#"> 
#<state4xi status = "ACK4tagging; ACK4HW; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def get_name_current_process4xi():          
    '''
    get_name_current_process4xi returns the name of the current process
    '''
    global _current_process

    class2print = "get_name_current_process4xi"
    method2print = "get_name_current_process4xi"        
    
    message2print = "{started" + "; get-name-current-process4xi-started: " + str(get_name_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #HW: { get_name_current_process4xi : get_name_current_process4xi ; started; get-name-current-process4xi-started: <function get_name_current_process4xi at 0x02A46978>; time: 11:17:25 01/21/10 FLE Standard Time}
     
    
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-get-name-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
   
    message2print = "{returning" + "; current-process-name-returning-by-get-name-current-process4xi: " + str(_current_process._name) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    #HW: { get_name_current_process4xi : get_name_current_process4xi ; returning; current-process-name-returning-by-get-name-current-process4xi: MainProcess4Xi; time: 11:17:25 01/21/10 FLE Standard Time}
    
    
    return _current_process._name    
#</function4xi> 

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set-name-current-process4xi" usage = "
# sets the name to the current process
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def set_name_current_process4xi(param='MainProcess4Xi'):        
    '''
    set_name_current_process4xi sets the name to the current process
    '''
    global _current_process
    
    class2print = "set_name_current_process4xi"
    method2print = "set_name_current_process4xi"

    
    message2print = "{started" + "; set-name-current-process4xi-started: " + str(set_name_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
          
    
    
    message2print = "{passed" + "; param-passed-to-set-name-current-process4xi-by-set-name-current-process4xi: " + str(param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
        
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------  
  

    if param is None:
        param = 'MainProcess4Xi'
    
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-set-name-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
      
    
    # make atomic; lock
    _current_process._name = param            
    # release lock                


    message2print = "{set; current-process-name-set-by-set-name-current-process4xi to: " + str(_current_process._name) + ";time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    
    message2print = "{returning" + "; set-name-current-process4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)           
#</function4xi> 

 
#6
# -------------------------------------------------------------------------------------------------
#<function4xi function = "init-counter-current-process4xi" usage = "
# initializes the counter of the current process
#"> 
#<state4xi status = "ACK4tagging; ACK4HW; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def init_counter_current_process4xi(param=itertools.count(1)):       
    '''
    init_counter_current_process4xi initializes the counter of the current process
    '''
    global _current_process

    class2print = "set_name_current_process4xi"
    method2print = "set_name_current_process4xi"
    
    
    message2print = "{started" + "; init-counter-current-process4xi-started: " + str(init_counter_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #HW: { set_name_current_process4xi : set_name_current_process4xi ; started; init-counter-current-process4xi-started: <function init_counter_current_process4xi at 0x02A46A08>; time: 11:17:25 01/21/10 FLE Standard Time}
      
    
    message2print = "{passed" + "; param-passed-to-init-counter-current-process4xi: " + str(param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    #HW: { set_name_current_process4xi : set_name_current_process4xi ; passed; param-passed-to-init-counter-current-process4xi: count(1); time: 11:17:25 01/21/10 FLE Standard Time}
    
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------  
  
    if param is None:
        param = itertools.count(1)
    
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-init-counter-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
       

    # make atomic; lock
    _current_process._counter = param            
    # release lock 

    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   

    message2print = "{set; current-process-counter-set-by-init-counter-current-process4xi to: " + str(_current_process._counter) + ";time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    #HW: { set_name_current_process4xi : set_name_current_process4xi ; set; current-process-counter-set-by-init-counter-current-process4xi to: count(1);time: 11:17:25 01/21/10 FLE Standard Time}
    
    message2print = "{returning" + "; init-counter-current-process4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    #HW: { set_name_current_process4xi : set_name_current_process4xi ; returning; init-counter-current-process4xi-returning: 11:17:25 01/21/10 FLE Standard Time}
         
#</function4xi> 

     
    
            
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-counter-current-process4xi" usage = "
# returns the counter of the current process
#"> 
#<state4xi status = "ACK4tagging; ACK4HW; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def get_counter_current_process4xi():          
    '''
    get_counter_current_process4xi returns the counter of the current process
    '''
    global _current_process

    class2print = "get_counter_current_process4xi"
    method2print = "get_counter_current_process4xi"  
    
    message2print = "{started" + "; get-counter-current-process4xi-started: " + str(get_counter_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #HW: { get_counter_current_process4xi : get_counter_current_process4xi ; started; get-counter-current-process4xi-started: <function get_counter_current_process4xi at 0x02A46A50>; time: 11:17:25 01/21/10 FLE Standard Time}
       
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-get-counter-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
      


    message2print = "{returning" + "; current-process-counter-returning-by-get-counter-current-process4xi: " + str(_current_process._counter) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    #HW: { get_counter_current_process4xi : get_counter_current_process4xi ; returning; current-process-counter-returning-by-get-counter-current-process4xi: count(1); time: 11:17:25 01/21/10 FLE Standard Time}
    
  
            
    return _current_process._counter    
#</function4xi> 

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set-counter-current-process4xi" usage = "
# sets the counter to the current process
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def set_counter_current_process4xi(param=itertools.count(1)):           
    '''
    set_counter_current_process4xi sets the counter to the current process
    '''
    global _current_process
    class2print = "set_counter_current_process4xi"
    method2print = "set_counter_current_process4xi"
    
    message2print = "{started" + "; set-counter-current-process4xi-started: " + str(set_counter_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
  
    
    message2print = "{passed" + "; param-passed-to-set-counter-current-process4xi: " + str(param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
          
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------  
      
    
    if param is None:
        param = itertools.count(1)  
    
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-set-counter-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
      
    
    # make atomic; lock
    _current_process._counter = param            
    # release lock                

    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   

    message2print = "{set; current-process-counter-set-by-set-counter-current-process4xi to: " + str(_current_process._counter) + ";time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{returning" + "; set-counter-current-process4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)       
#</function4xi> 

 
#7
# -------------------------------------------------------------------------------------------------
#<function4xi function = "init-daemonic-current-process4xi" usage = "
# initializes the boolean value daemonic for the current process
#"> 
#<state4xi status = "ACK4tagging; ACK4HW; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def init_daemonic_current_process4xi(param=False):          
    '''
    init_daemonic_current_process4xi initializes the boolean value daemonic for the current process
    '''
    global _current_process
    class2print = "init_daemonic_current_process4xi"
    method2print = "init_daemonic_current_process4xi"
    
    
    message2print = "{started" + "; init-daemonic-current-process4xi-started: " + str(init_daemonic_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #HW: { init_daemonic_current_process4xi : init_daemonic_current_process4xi ; started; init-daemonic-current-process4xi-started: <function init_daemonic_current_process4xi at 0x02A46AE0>; time: 11:17:25 01/21/10 FLE Standard Time}

  
    
    message2print = "{passed" + "; param-passed-to-init-daemonic-current-process4xi: " + str(param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    #HW: { init_daemonic_current_process4xi : init_daemonic_current_process4xi ; passed; param-passed-to-init-daemonic-current-process4xi: False; time: 11:17:25 01/21/10 FLE Standard Time}
    
           
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------  
  

    if param is None:
        param = False
    
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-init-daemonic-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
     
    
    # make atomic; lock
    _current_process._daemonic = param            
    # release lock 

    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   

    message2print = "{initialized" + "; current-process-daemonic-initialized-by-init-daemonic-current-process4xi to: " + str(_current_process._daemonic)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    #HW: { init_daemonic_current_process4xi : init_daemonic_current_process4xi ; initialized; current-process-daemonic-initialized-by-init-daemonic-current-process4xi to: False; time: 11:43:12 01/21/10 FLE Standard Time}
            
    
    message2print = "{returning" + "; init-daemonic-current-process4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)         
    #HW: { init_daemonic_current_process4xi : init_daemonic_current_process4xi ; returning; init-daemonic-current-process4xi-returning: 11:43:12 01/21/10 FLE Standard Time}
    
#</function4xi> 

 
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-daemonic-current-process4xi" usage = "
# returns the daemonic of the current process
#"> 
#<state4xi status = "ACK4tagging; ACK4HW; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def get_daemonic_current_process4xi():          
    '''
    get_daemonic_current_process4xi returns the daemonic of the current process
    '''
    global _current_process
    
    class2print = "get_daemonic_current_process4xi"
    method2print = "get_daemonic_current_process4xi"
    
    message2print = "{started" + "; get-daemonic-current-process4xi-started: " + str(get_daemonic_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #HW: { get_daemonic_current_process4xi : get_daemonic_current_process4xi ; started; get-daemonic-current-process4xi-started: <function get_daemonic_current_process4xi at 0x02ADCB28>; time: 11:43:12 01/21/10 FLE Standard Time}


           
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-get-daemonic-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
  

    message2print = "{returning" + "; current-process-daemonic-returning-by-get-daemonic-current-process4xi: " + str(_current_process._daemonic) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    #HW: { get_daemonic_current_process4xi : get_daemonic_current_process4xi ; returning; current-process-daemonic-returning-by-get-daemonic-current-process4xi: False; time: 11:43:12 01/21/10 FLE Standard Time}
    
          
    return _current_process._daemonic    
#</function4xi> 

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set-daemonic-current-process4xi" usage = "
# sets the boolean value daemonic to the current process
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def set_daemonic_current_process4xi(param=False):           
    '''
    set_daemonic_current_process4xi sets the boolean value daemonic to the current process
    '''
    global _current_process
    class2print = "set_daemonic_current_process4xi"
    method2print = "set_daemonic_current_process4xi"    
    
    
    message2print = "{started" + "; set-daemonic-current-process4xi-started: " + str(set_daemonic_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
      
    
    message2print = "{passed" + "; param-passed-to-set-daemonic-current-process4x: " + str(param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
            
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------  
  
    
    if param is None:
        param = False
    
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-set-daemonic-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
    
    
    # make atomic; lock
    _current_process._daemonic = param            
    # release lock                        


    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   

    message2print = "{set; current-process-daemonic-set-by-set-daemonic-current-process4xi to: " + str(_current_process._daemonic) + ";time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{returning" + "; set-daemonic-current-process4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)     
#</function4xi> 

    
#8
# -------------------------------------------------------------------------------------------------
#<function4xi function = "init-tempdir-current-process4xi" usage = "
# initializes the tempdir of the current process
#"> 
#<state4xi status = "ACK4tagging; ACK4HW; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def init_tempdir_current_process4xi(param=None):         
    '''
    init_tempdir_current_process4xi initializes the tempdir of the current process
    '''
    global _current_process
    class2print = "init_tempdir_current_process4xi"
    method2print = "init_tempdir_current_process4xi"
    
    
    message2print = "{started" + "; init-tempdir-current-process4xi-started: " + str(init_tempdir_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #HW: { init_tempdir_current_process4xi : init_tempdir_current_process4xi ; started; init-tempdir-current-process4xi-started: <function init_tempdir_current_process4xi at 0x02ADCBB8>; time: 11:43:12 01/21/10 FLE Standard Time}

  
    
    message2print = "{passed" + "; param-passed-to-init-tempdir-current-process4xi: " + str(param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    #HW: { init_tempdir_current_process4xi : init_tempdir_current_process4xi ; passed; param-passed-to-init-tempdir-current-process4xi: None; time: 11:43:12 01/21/10 FLE Standard Time}
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------  
  

    if param is None:
        param = tempfile.mkdtemp(prefix='pymp-')
    
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-init-tempdir-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
    
    
    # make atomic; lock
    _current_process._tempdir = param            
    # release lock 

    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   

    message2print = "{set; current-process-tempdir-set-by-init-tempdir-current-process4xi to: " + str(_current_process._tempdir) + ";time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    #HW: { init_tempdir_current_process4xi : init_tempdir_current_process4xi ; set; current-process-tempdir-set-by-init-tempdir-current-process4xi to: c:\users\ceo4dr~1\appdata\local\temp\pymp-dsk17b;time: 11:43:12 01/21/10 FLE Standard Time}


    
    message2print = "{returning" + "; init-tempdir-current-process4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    #HW: { init_tempdir_current_process4xi : init_tempdir_current_process4xi ; returning; init-tempdir-current-process4xi-returning: 11:43:12 01/21/10 FLE Standard Time}
      
#</function4xi> 

  
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-tempdir-current-process4xi" usage = "
# returns the tempdir of the current process
#"> 
#<state4xi status = "ACK4tagging; ACK4HW; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def get_tempdir_current_process4xi():          
    '''
    get_tempdir_current_process4xi returns the tempdir of the current process
    '''
    global _current_process

    class2print = "get_tempdir_current_process4xi"
    method2print = "get_tempdir_current_process4xi"   
    
    message2print = "{started" + "; get-tempdir-current-process4xi-started: " + str(get_tempdir_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #HW: { get_tempdir_current_process4xi : get_tempdir_current_process4xi ; started; get-tempdir-current-process4xi-started: <function get_tempdir_current_process4xi at 0x02ADCC00>; time: 11:43:12 01/21/10 FLE Standard Time}


    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   

    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-get-tempdir-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
   
          
    if _current_process._tempdir is None:
        _current_process._tempdir = tempfile.mkdtemp(prefix='pymp-')
        
    message2print = "{returning" + "; current-process-tempdir-returning-by-get-tempdir-current-process4xi: " + str(_current_process._tempdir) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    #HW: { get_tempdir_current_process4xi : get_tempdir_current_process4xi ; returning; current-process-tempdir-returning-by-get-tempdir-current-process4xi: c:\users\ceo4dr~1\appdata\local\temp\pymp-dsk17b; time: 11:43:12 01/21/10 FLE Standard Time}

  
            
    return _current_process._tempdir    
#</function4xi> 

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set-tempdir-current-process4xi" usage = "
# sets the tempdir to the current process
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def set_tempdir_current_process4xi(param=None):          
    '''
    set_tempdir_current_process4xi sets the tempdir to the current process
    '''
    global _current_process
    class2print = "set_tempdir_current_process4xi"
    method2print = "set_tempdir_current_process4xi"    
    
    
    message2print = "{started" + "; set-tempdir-current-process4xi-started: " + str(set_tempdir_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
      
    
    message2print = "{passed" + "; param-passed-to-set-tempdir-current-process4xi: " + str(param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
     
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------  
  
    if param is None:
        param = tempfile.mkdtemp(prefix='pymp-')
    
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-set-tempdir-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
   
    
    # make atomic; lock
    _current_process._tempdir = param            
    # release lock                       

    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   

    message2print = "{set; current-process-tempdir-set-by-set-tempdir-current-process4xi to: " + str(_current_process._tempdir) + ";time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{returning" + "; set-tempdir-current-process4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)            
#</function4xi> 

       

#9
# -------------------------------------------------------------------------------------------------
#<function4xi function = "add-child-current-process4xi" usage = "
# adds a child to the current process
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4HW; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def add_child_current_process4xi(param=None):         
    '''
    add_child_current_process4xi adds a child to the current process
    '''
    global _current_process
    class2print = "add_child_current_process4xi"
    method2print = "add_child_current_process4xi"
    
    message2print = "{started" + "; add-child-current-process4xi-started: " + str(add_child_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #HW: { add_child_current_process4xi : add_child_current_process4xi ; started; add-child-current-process4xi-started: <function add_child_current_process4xi at 0x02ADCC90>; time: 11:43:12 01/21/10 FLE Standard Time}
    
    #to-be-solved:
    #{ Process4Xi : __repr__ ; started; repr-of-Process4Xi-started: ; time: 11:43:12 01/21/10 FLE Standard Time} <-- starts first as a presenter
    #{ MainProcess4Xi : __repr__ ; (Step 1/7) started; repr-of-MainProcess4Xi-started: 11:43:12 01/21/10 FLE Standard Time} <-- starts second as a presenter
    #
    #{ MainProcess4Xi : __repr__ ; (Step 2/7) got; parent-pid-of-mainprocess2xi-got-by-repr-of-MainProcess4Xi: None; time: 11:43:12 01/21/10 FLE Standard Time}
    #{ MainProcess4Xi : __repr__ ; (Step 3/7) got; ospid2xi-got-by-repr-of-MainProcess4Xi: 1964; time: 11:43:12 01/21/10 FLE Standard Time}
    #{ MainProcess4Xi : __repr__ ; (Step 4/7) got; popen-of-mainprocess2xi-got-by-repr-of-MainProcess4Xi: None; time: 11:43:12 01/21/10 FLE Standard Time}
    #{ MainProcess4Xi : __repr__ ; (Step 5/7) skipped; Step-5-of-7-skipped-by-repr-of-MainProcess4Xi: *** to-be-done: poll2xi = self._popen.poll() ***; time: 11:43:12 01/21/10 FLE Standard Time}
    #{ MainProcess4Xi : __repr__ ; (Step 6/7a) do; Step-6-of-7-do-by-repr-of-MainProcess4Xi: ** to-be-done: (Step 6/7a) r2xi = Process.__repr__(self) **; time: 11:43:12 01/21/10 FLE Standard Time}
    #{ MainProcess4Xi : __repr__ ; (Step 6/7b) got; r2xi-got-by-repr-of-MainProcess4Xi: <MainProcess4Xi(MainProcess4Xi, unknown)>; time: 11:43:12 01/21/10 FLE Standard Time}
    #{ MainProcess4Xi : __repr__ ; (Step 7/7) returning; r2xi-returning-by-repr-of-MainProcess4X: <MainProcess4Xi(MainProcess4Xi, unknown)>; time: 11:43:12 01/21/10 FLE Standard Time}


    message2print = "{passed" + "; param-passed-to-add-child-current-process4xi: " + str(param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
        
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------  
  

    #assert param is None, 'current_process4xi.py: add _child_current_process4xi has to get child parameter'
    if param is None:
  
        
        message2print = "{returning" + "; error-returning-by-add-child-current-process4xi: " + " *** " + "param to add-child-current-process4xi is None - to be solved"  + " *** " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        return
    
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-add-child-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
    

  
    # make atomic; lock
    _current_process._children.add(param)         
    # release lock 

    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   

    message2print = "{set; current-process-children-set-by-add-child-current-process4xi to: " + str(_current_process._children) + ";time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    #HW: {<Process4Xi(Process4Xi-1, stopped)>}
    #PX: {<Process4Xi(SyncManager4Xi-1, stopped)>}
#</function4xi> 

 
                
# -------------------------------------------------------------------------------------------------
#<function4xi function = "discard-child-current-process4xi" usage = "
# discards a child of the current process
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def discard_child_current_process4xi(param=None):         
    '''
    discard_child_current_process4xi discards a child of the current process
    '''
    global _current_process

    class2print = "discard_child_current_process4xi"
    method2print = "discard_child_current_process4xi"
    
    
    message2print = "{started" + "; discard-child-current-process4xi-started: " + str(discard_child_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
      
    
    message2print = "{passed" + "; param-passed-to-discard-child-current-process4xi: " + str(param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
            
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------  
  

    if param is None:
        
        message2print = "{returning" + "; error-returning-by-discard-child-current-process4xi: " + " *** " + "param to discard-child-current-process4xi is None - to be solved"  + " *** " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
    
        return
    
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-discard-child-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
      
        
    # make atomic; lock
    _current_process._children.discard(param)         
    # release lock     

    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   

    message2print = "{set; current-process-children-set-by-discard-child-current-process4xi to: " + str(_current_process._children) + ";time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{returning" + "; discard-child-current-process4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)       
    
    
    #{ discard_child_current_process4xi : discard_child_current_process4xi ; returning after having _current_process._children set to: 
    # {<Process4Xi(SyncManager4Xi-2, stopped)>} ;time: 11:22:39 07/03/09 FLE Daylight Time}
    
    # { discard_child_current_process4xi : discard_child_current_process4xi ; returning after having _current_process._children set to:
    #   set();time: 11:22:39 07/03/09 FLE Daylight Time}

#</function4xi> 

                
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-children-current-process4xi" usage = "
# returns the children of the current process children
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def get_children_current_process4xi():          
    '''
    get_children_current_process4xi returns the children of the current process children
    '''
    global _current_process

    class2print = "get_children_current_process4xi"
    method2print = "get_children_current_process4xi"  
    
    message2print = "{started" + "; get-children-current-process4xi-started: " + str(get_children_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
        
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   

    
    if _current_process is None:
        init_current_process4xi()
        
        message2print = "{warned" + "; current-process-warned-by-get-children-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
       

    message2print = "{returning" + "; current-process-children-returning-by-get-children-current-process4xi: " + str(_current_process._children) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    
    return _current_process._children         
#</function4xi> 

 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "list-children-current-process4xi" usage = "
#   returns the list of the current process children
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def list_children_current_process4xi():          
    '''
    list_children_current_process4xi returns the list of the current process children
    '''
    global _current_process
    
    class2print = "list_children_current_process4xi"
    method2print = "list_children_current_process4xi" 
    
    message2print = "{started" + "; list-children-current-process4xi-started: " + str(list_children_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------  
  
   
    if _current_process is None:
        
        init_current_process4xi()
        
        message2print = "{warned" + "; current-process-warned-by-list-children-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
   
    

    message2print = "{returning" + "; list-returning-by-list-children-current-process4xi: " + str(list(_current_process._children)) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      

    
    #{ list_children_current_process4xi : list_children_current_process4xi ; returning list(_current_process._children): 
    #[<Process4Xi(SyncManager4Xi-3, stopped)>,
    # <Process4Xi(SyncManager4Xi-2, stopped)>]; time: 11:22:39 07/03/09 FLE Daylight Time}        
    
    return list(_current_process._children)     
#</function4xi> 

 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "init-children-current-process4xi" usage = "
# returns the list of the current process children
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def init_children_current_process4xi():          
    '''
    list_children_current_process4xi returns the list of the current process children
    '''
    global _current_process
    
    class2print = "init_children_current_process4xi"
    method2print = "init_children_current_process4xi" 
    
    message2print = "{started" + "; init-children-current-process4xi-started: " + str(init_children_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
     
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------  
  

    message2print = "{started time: " + time4xi() + "}"


    
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-init-children-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
    
    _current_process._children = set()  #Notes: () =tuple and has no add  #{}=dict []=list     

    message2print = "{initialized" + "; current-process-children-initialized-by-init-children-current-process4xi to: " + str(_current_process._children)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
            
    
    message2print = "{returning" + "; init-children-current-process4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
#</function4xi> 

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set-children-current-process4xi" usage = "
# sets the list of the current process children
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def set_children_current_process4xi():          
    '''
    set_children_current_process4xi sets the list of the current process children
    '''
    global _current_process
    class2print = "set_children_current_process4xi"
    method2print = "set__children_current_process4xi"
    
    message2print = "{started" + "; set-children-current-process4xi-started: " + str(set_children_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
      
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------  
  

    message2print = "{started time: " + time4xi() + "}"


    
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-set-children-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
     
    
    _current_process._children = set()           

    message2print = "{set; current-process-children-set-by-set-children-current-process4xi to: " + str(_current_process._children) + ";time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{returning" + "; set-children-current-process4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
#</function4xi> 

                 
#10
# -------------------------------------------------------------------------------------------------
#<function4xi function = "init-manager-server-current-process4xi" usage = "
# 
# server4xi:
#     class Server4Xi:
#         serve_forever
#             set_manager_server_current_process4xi(self)
# managers.py:
#     class Server:
#         serve_forever:         
#             current_process()._manager_server = self
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def init_manager_server_current_process4xi(manager_object):     
    '''
    init_manager_server_current_process4xi initializes the manager_server of the current process
    '''
    global _current_process

    # ---------------------------------------------------------------------------------------------    
    # (Step 1/5)
    # ---------------------------------------------------------------------------------------------      
    class2print = "init_manager_server_current_process4xi"
    method2print = "init_manager_server_current_process4xi"
    
    
    message2print = "{(Step 1/5a) started" + "; init-manager-server-current-process4xi-started: " + str(init_manager_server_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
      
    
    message2print = "{(Step 1/5b) passed" + "; manager-object-passed-to-init-manager-server-current-process4xi: " + str(manager_object) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
  
        
    # ---------------------------------------------------------------------------------------------    
    # (Step 2/5)
    # ---------------------------------------------------------------------------------------------  
    if manager_object is None:
        
        message2print = "{(Step 2/5) returning" + "; error-returning-by-init-manager-server-current-process4xi: " + " *** " + "manager-object to init-manager-server-current-process4xi is None - to be solved"  + " *** " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
           

        return    
    
    # ---------------------------------------------------------------------------------------------    
    # (Step 3/5)
    # ---------------------------------------------------------------------------------------------     
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{(Step 3/5) warned" + "; current-process-warned-by-init-manager-server-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
      
  
    # ---------------------------------------------------------------------------------------------    
    # (Step 4/5)
    # ---------------------------------------------------------------------------------------------      
    # make atomic; lock
    _current_process._manager_server = manager_object            
    # release lock                                

    message2print = "{(Step 4/5) initialized; current-process-manager-server-initialized-by-init-manager-server-current-process4xi to: " + str(_current_process._manager_server)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    # ---------------------------------------------------------------------------------------------    
    # (Step 5/5)
    # ---------------------------------------------------------------------------------------------   

    message2print = "{(Step 5/5) returning" + "; init-manager-server-current-process4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)     
#</function4xi> 

 
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-manager-server-current-process4xi" usage = "
# returns the manager_server of the current process
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def get_manager_server_current_process4xi():          
    '''
    get_manager_server_current_process4xi returns the manager_server of the current process
    '''
    global _current_process

    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    class2print = "get_manager_server_current_process4xi"
    method2print = "get_manager_server_current_process4xi"
    
    message2print = "{started" + "; get-manager-server-current-process4xi-started: " + str(get_manager_server_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
  
    
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{warned" + "; current-process-warned-by-get-manager-server-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
       
   
    message2print = "{returning" + "; current-process-manager-server-returning-by-get-manager-server-current-process4xi: " + str(_current_process._manager_server) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      

    
    return _current_process._manager_server    
#</function4xi> 

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set-manager-server-current-process4xi" usage = "
# 
# server4xi:
#     class Server4Xi:
#         serve_forever
#             set_manager_server_current_process4xi(self)
# managers.py:
#     class Server:
#         serve_forever:         
#             current_process()._manager_server = self
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def set_manager_server_current_process4xi(manager_object):           
    '''
    set_manager_server_current_process4xi sets the manager_server to the current process
    '''
    global _current_process
    
    # ---------------------------------------------------------------------------------------------    
    # (Step 1/5)
    # ---------------------------------------------------------------------------------------------      
    class2print = "set_manager_server_current_process4xi"
    method2print = "set_manager_server_current_process4xi"
    
    message2print = "{(Step 1/5a) started" + "; set-manager-server-current-process4xi-started: " + str(set_manager_server_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
      
    
    message2print = "{(Step 1/5b) passed" + "; manager-object-passed-to-set-manager-server-current-process4xi: " + str(manager_object) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
  
        
    # ---------------------------------------------------------------------------------------------    
    # (Step 2/5)
    # ---------------------------------------------------------------------------------------------  
    if manager_object is None:
        
        message2print = "{(Step 2/5) hit; error-hit: *** given parameter manager_object is None - to be solved ! *** ;time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        return    
    
    # ---------------------------------------------------------------------------------------------    
    # (Step 3/5)
    # ---------------------------------------------------------------------------------------------     
    if _current_process is None:
        init_current_process4xi() 
        
        message2print = "{(Step 3/5) warned" + "; current-process-warned-by-set-manager-server-current-process4xi: ** _current_process was None and got initialized - to be solved " + str(_current_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
           
  
    # ---------------------------------------------------------------------------------------------    
    # (Step 4/5)
    # ---------------------------------------------------------------------------------------------      
    # make atomic; lock
    _current_process._manager_server = manager_object            
    # release lock                                

    message2print = "{(Step 4/5) set; current-process-manager-server-set-by-set-manager-server-current-process4xi to: " + str(_current_process._manager_server)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    # ---------------------------------------------------------------------------------------------    
    # (Step 5/5)
    # ---------------------------------------------------------------------------------------------   
    message2print = "{(Step 5/5) returning" + "; set-manager-server-current-process4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
#</function4xi> 

                                                                                     
#All#
# -------------------------------------------------------------------------------------------------
#<function4xi function = "init-all-current-process4xi" usage = "
#     gets a process object as a parameter
#     a method calling this function or CurrentProcess4Xi method passes self = its caller process such as Process4Xi (see _bootstrap method)
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def init_all_current_process4xi(caller_object=None, caller_type=False):          
    '''
    init_all_current_process4xi initializes all for caller_object which then becomes the current_process
    '''
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    
    class2print = "init_all_current_process4xi"
    method2print = "init_all_current_process4xi"
        
    message2print = "{started" + "; init-all-current-process4xi-started: " + str(init_all_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
                  
    
    message2print = "{passed" + "; caller-object-passed-to-init-all-current-process4xi: " + str(caller_object) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    
    message2print = "{passed" + "; caller-type-passed-to-init-all-current-process4xi: " + str(caller_type) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
        
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   

    #1
    init_current_process4xi(caller_object)  #<-- this is THE only one which needs caller_object!                            
    #2
    init_inheriting_current_process4xi()      
    #3
    init_authkey_current_process4xi()
    #4
    init_identity_current_process4xi() 
    #5
    init_name_current_process4xi()      
    #6
    init_counter_current_process4xi()
    #7
    init_daemonic_current_process4xi()
    #8
    init_tempdir_current_process4xi()
    #10
    init_manager_server_current_process4xi(caller_object)
    #11
    init_children_current_process4xi()
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    
    message2print = "{returning" + "; init-all-current-process4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)       
#</function4xi> 

 
        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set_all_current_process4xi" usage = "
#     gets a process object as a parameter
#     a method calling this function or CurrentProcess4Xi method passes self = its caller process such as Process4Xi (see _bootstrap method)
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def set_all_current_process4xi(caller_object=None, caller_type=False):          
    '''
    set_all_current_process4xi sets all for current process
    '''
                
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    class2print = "set_all_current_process4xi"
    method2print = "set_all_current_process4xi"
    
        
    message2print = "{started" + "; set-all-current-process4xi-started: " + str(set_all_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
   
    
    message2print = "{passed" + "; caller-object-passed-to-set-all-current-process4xi: " + str(caller_object) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    
    message2print = "{passed" + "; caller-type-passed-to-set-all-current-process4xi: " + str(caller_type) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    

    #1
    set_current_process4xi(caller_object)  #<-- this is THE only one which needs caller_object!                
    #2
    set_inheriting_current_process4xi()      
    #3
    set_authkey_current_process4xi()
    #4
    set_identity_current_process4xi() 
    #5
    set_name_current_process4xi()      
    #6
    set_counter_current_process4xi()
    #7
    set_daemonic_current_process4xi()
    #8
    set_tempdir_current_process4xi()
    #10
    set_manager_server_current_process4xi(caller_object)
    #12
    set_children_current_process4xi()    
 
    message2print = "{returning" + "; set-all-current-process4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)  
#</function4xi> 

      
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-all-current-process4xi" usage = "
# gets all for current current process
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def get_all_current_process4xi():          
    '''
    get_all_current_process4xi gets all for current current process
    '''
         
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    class2print = "get_all_current_process4xi"
    method2print = "get_all_current_process4xi"
        
    message2print = "{started" + "; get-all-current-process4xi-started: " + str(get_all_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
   


    print("get_all_current_process4xi")
    for i in range(0,1):
        print("current_process4xi.py currents(", i, ") = ", current_process4xi(i))
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
 

    message2print = "{returning" + "; true-returning-by-get-all-current-process4xi: True" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)       
    
        
    return True

#</function4xi> 

     
   
#ONE#    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-one-current-process4xi" usage = "
# gets one process current
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def get_one_current_process4xi(param=0):          
    '''
    get_one_current_process4xi gets one process current
    '''
                
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    class2print = "get_one_current_process4xi"
    method2print = "get_one_current_process4xi"
    
        
    message2print = "{started" + "; get-one-current-process4xi-started: " + str(get_one_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
   
    
    message2print = "{passed" + "; param-passed-to-get-one-current-process4xi: " + str(param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
     
    
    
    if param <= 0 or param > 0:
        param = 0    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   

    message2print = "{passing" + "; param-passing-by-get-one-current-process4xi: " + str(param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
  
    
    message2print = "{returning" + "; value-current-process-process4xi-returning-by-get-one-current-process4xi: " + str(value_current_process_process4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      

    message2print = "{returning" + "; value-current-process-process4xi-function-returning-by-get-one-current-process4xi: " + str(value_current_process_process4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
        
    return value_current_process_process4xi(param)        
#</function4xi> 

     

#ALL
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-all-current-process4xi" usage = "
# gets all process currents
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def get_all_current_process4xi():          
    '''
    get_all_current_process4xi gets all process currents
    '''
    # ---------------------------------------------------------------------------------------------
    # could return True after loading an OWL/XML file into memory 
    # ---------------------------------------------------------------------------------------------    
                
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    class2print = "get_all_current_process4xi"
    method2print = "get_all_current_process4xi"
    
        
    message2print = "{started" + "; get-all-current-process4xi-started: " + str(get_all_current_process4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
   

    for i in range(0,11):
        message2print = "{got" + "; value-current-process4xi-got-by-get-all-current-process4xi: " + str(value_current_process4xi(i)) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    message2print = "{returning" + "; true-returning-by-get-all-current-process4xi: True" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
   
    
        
    return True    
#</function4xi> 

     
# =================================================================================================
#<class4xi class = "CurrentProcess4Xi" base = "object" child = "None" synopsis = "Class for the current process" usage = "
# process4xi.py:
#     cp2xi = CurrentProcess4Xi() # <-- dragonized _current_process = self of process.py 
# syncmanager4xi.py:
#     cp2xi = CurrentProcess4Xi()
#"
#>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
class CurrentProcess4Xi(object): 
    '''  
    CurrentProcess4Xi offers services for current process
    '''            

    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi exposure = "
    _exposed_ = ('init_all_current','set_all_current','get_all_current','get_one_current',
                 'init_current','set_current','get_current',
                 'init_inheriting_current','set_inheriting_current','get_inheriting_current',   
                 'init_authkey_current','set_authkey_current','get_authkey_current',
                 'init_identity_current','set_identity_current','get_identity_current',
                 'init_name_current','set_name_current','get_name_current',
                 'init_counter_current','set_counter_current','get_counter_current',
                 'init_daemonic_current','set_daemonic_current','get_daemonic_current',
                 'init_tempdir_current', 'set_tempdir_current','get_tempdir_current',
                 'add_child_current','discard_child_current','get_children_current',
                 'init_manager_server_current','set_manager_server_current','get_manager_server_current',                                                               
                 'sense', 'reason', 'ace')             
    #"
    #/>
                                     
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-CurrentProcess4Xi" usage = "
    #    process4xi.py 
    #        _bootstrap(self):
    #            cp2xi = CurrentProcess4Xi(self, True)  # dragonized _current_process = self; self is the "True" process object becoming the _current_process 
    #            cp2xi.init_all_current(self, True) 
    #">
    #<state4xi status = "ACK4tagging; ACK4HW; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------   
    def __init__(self, caller_type): 
              #  self = the caller of this class, 
              #  caller_type = True  = it's a process object type such as Process4Xi wanting to make it's self to _current_process
              #              = False = it's a module such as a test program wanting to make MainProcess4Xi  to _current_process 
        '''
        initializes CurrentProcess4Xi objects
        '''       
        # -----------------------------------------------------------------------------------------
        #         
        # -----------------------------------------------------------------------------------------
        class2print = "CurrentProcess4Xi"
        method2print = "__init__"
        
        
        message2print = "{started" + "; init-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # { CurrentProcess4Xi : __init__ ; started; init-of-CurrentProcess4Xi-started: <current_process4xi.CurrentProcess4Xi object at 0x02E9E7F0>; time: 14:38:21 01/07/10 FLE Standard Time} 
       
        message2print = "{borning" + "; currentprocess2xi-of-CurrentProcess4Xi-borning: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # { CurrentProcess4Xi : __init__ ; borning; object-of-CurrentProcess4Xi-borning: <current_process4xi.CurrentProcess4Xi object at 0x02E9E7F0>; time: 14:38:21 01/07/10 FLE Standard Time} 

        message2print = "{inheriting" + "; object-inheriting-by-currentprocess2xi-of-CurrentProcess4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
          
        message2print = "{passed" + "; caller-type-passed-to-init-of-CurrentProcess4Xi: " + str(caller_type) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # { CurrentProcess4Xi : __init__ ; passed; caller-type-passed-to-init-of-CurrentProcess4Xi: False; time: 14:38:21 01/07/10 FLE Standard Time}          

        init_all_current_process4xi(self, caller_type) # pass self i.e. the caller of this class as parameter        
        
        message2print = "{activated" + "; currentprocess2xi-of-CurrentProcess4Xi-activated: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # { CurrentProcess4Xi : __init__ ; activated; object-of-CurrentProcess4Xi-activated: <current_process4xi.CurrentProcess4Xi object at 0x02E9E7F0>; time: 14:38:21 01/07/10 FLE Standard Time} 

        message2print = "{inherited" + "; object-inherited-by-currentprocess2xi-of-CurrentProcess4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
             
        message2print = "{returning" + "; init-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # { CurrentProcess4Xi : __init__ ; returning; init-of-CurrentProcess4Xi-returning: 14:38:21 01/07/10 FLE Standard Time}
        
    #</methodize4xi>
            
    # -------------------------------------------------------------------------------------------------
    # NOTE: do NOT pass self as the first parameter to init and set functions
    #       this is because self of this class i.e. the caller might NOT be a Process4Xi type object! 
    # -------------------------------------------------------------------------------------------------           
        
            
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-all-current-of-CurrentProcess4Xi" usage = "initializes for current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------   
    def init_all_current(self, caller_type): 
        '''
        init_all_current method initializes for current process
        '''       
        class2print = "CurrentProcess4Xi"
        method2print = "init_all_current"
        
        
        message2print = "{started" + "; init-all-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
  
        message2print = "{passed" + "; caller-type-passed-to-init-all-current-of-CurrentProcess4Xi: " + str(caller_type) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  
        
        init_all_current_process4xi(self, caller_type)  

        message2print = "{returning" + "; init-all-current-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
    #</methodize4xi>
         
         
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-all-current-of-CurrentProcess4Xi" usage = "sets all for current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------   
    def set_all_current(self, caller_type):
        '''
        set_all_current method sets all for current process
        '''       
        class2print = "CurrentProcess4Xi"
        method2print = "set_all_current"
        
        
        message2print = "{started" + "; set-all-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
  
        message2print = "{passed" + "; caller-type-passed-to-set-all-current-of-CurrentProcess4Xi: " + str(caller_type) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  
        set_all_current_process4xi(self, caller_type)       

        message2print = "{returning" + "; set-all-current-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
    #</methodize4xi>
       
 
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-all-current-of-CurrentProcess4Xi" usage = "gets all for current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------   
    def get_all_current(self):
        '''
        get_all_current method gets all for current process
        '''       
        class2print = "CurrentProcess4Xi"
        method2print = "get_all_current"
        
        
        message2print = "{started" + "; get-all-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
  
  
        message2print = "{returning" + "; get-all-current-function-returning-by-get-all-current-of-CurrentProcess4Xi: " + str(get_all_current_process4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
  
        return get_all_current_process4xi() #prints and returns True   
    #</methodize4xi>
    
    #One
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-one-current-of-CurrentProcess4Xi" usage = "gets one for current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------   
    def get_one_current(self, param=0):
        '''
        get_one_current method gets one for current process
        '''       
        class2print = "CurrentProcess4Xi"
        method2print = "get_one_current"
        
        
        message2print = "{started" + "; get-one-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
        message2print = "{passed" + "; param-passed-to-get-one-current-of-CurrentProcess4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  
  
        message2print = "{returning" + "; get-one-current-function-returning-by-get-one-current-of-CurrentProcess4Xi: " + str(get_one_current_process4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
  
        return get_one_current_process4xi(param)      
    #</methodize4xi>
                
    #1#
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-current-of-CurrentProcess4Xi" usage = "initializes _current_process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def init_current(self, caller_type):          
        '''
        init_current initializes _current_process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "init_current"
        
        message2print = "{started" + "; init-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
  
        message2print = "{passed" + "; caller-type-passed-to-init-current-of-CurrentProcess4Xi: " + str(caller_type) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  
        init_current_process4xi(self, caller_type)  

        message2print = "{returning" + "; init-current-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
    #</methodize4xi>
      
     
    
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-current-of-CurrentProcess4Xi" usage = "sets _current_process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def set_current(self, caller_type):          
        '''
        set_current sets _current_process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "set_current"
        
        
        message2print = "{started" + "; set-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
        message2print = "{passed" + "; caller_type-passed-to-set-current-of-CurrentProcess4Xi: " + str(caller_type) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  

        set_current_process4xi(self, caller_type)   

        message2print = "{returning" + "; set-current-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
    #</methodize4xi>
         
         
        
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-current-of-CurrentProcess4Xi" usage = "gets _current_process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def get_current(self):          
        '''
        get_current gets _current_process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "get_current"
        
        message2print = "{started" + "; get-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
  
  
        message2print = "{returning" + "; get-current-function-returning-by-get-current-of-CurrentProcess4Xi: " + str(get_current_process4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
  
        return get_current_process4xi()
    #</methodize4xi>
        
    #2#
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-inheriting-current-of-CurrentProcess4Xi" usage = "initializes the inheritance of the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def init_inheriting_current(self, param=True):          
        '''
        init_inheriting_current initializes the inheritance of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "init_inheriting_current"
        
        
        message2print = "{started" + "; init-inheriting-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
        
        message2print = "{passed" + "; param-passed-to-init-inheriting-current-of-CurrentProcess4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  

        init_inheriting_current_process4xi(param)   
    

        message2print = "{returning" + "; init-inheriting-current-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
    #</methodize4xi>
         
     
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-inheriting-current-of-CurrentProcess4Xi" usage = "sets the inheritaqnce of the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def set_inheriting_current(self, param=True):          
        '''
        set_inheriting_current sets the inheritaqnce of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "set_inheriting_current"
        
        message2print = "{started" + "; set-inheriting-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
        message2print = "{passed" + "; param-passed-to-set-inheriting-current-of-CurrentProcess4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  

        set_inheriting_current_process4xi(param)   
        

        message2print = "{returning" + "; set-inheriting-current-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
    #</methodize4xi>
      
         
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-inheriting-current-of-CurrentProcess4Xi" usage = "gets the inheritance info of the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def get_inheriting_current(self):          
        '''
        get_inheriting_current gets the inheritance info of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "get_inheriting_current"
        
        message2print = "{started" + "; get-inheriting-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
  
        message2print = "{returning" + "; get-inheriting-current-function-returning-by-get-inheriting-current-of-CurrentProcess4Xi: " + str(get_inheriting_current_process4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
    

        return get_inheriting_current_process4xi()
    #</methodize4xi>
            
    #3#
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-authkey-current-of-CurrentProcess4Xi" usage = "initializes the authkey of the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def init_authkey_current(self, param=os.urandom(32)):          
        '''
        init_authkey_current initializes the authkey of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "init_authkey_current"
        
        message2print = "{started" + "; init-authkey-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
        message2print = "{passed" + "; param-passed-to-init-authkey-current-of-CurrentProcess4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  

        init_authkey_current_process4xi(param)

        message2print = "{returning" + "; init-authkey-current-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
    #</methodize4xi>
          
     
    
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-authkey-current-of-CurrentProcess4Xi" usage = "sets the authkey of the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def set_authkey_current(self, param=os.urandom(32)):          
        '''
        set_authkey_current sets the authkey of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "set_authkey_current"
        
        
        message2print = "{started" + "; set-authkey-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
        message2print = "{passed" + "; param-passed-to-set-authkey-current-of-CurrentProcess4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  

        set_authkey_current_process4xi(param)

        message2print = "{returning" + "; set-authkey-current-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
    #</methodize4xi>
      
        
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-authkey-current-of-CurrentProcess4Xi" usage = "gets the authkey info of the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def get_authkey_current(self):          
        '''
        get_authkey_current gets the authkey info of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "get_authkey_current"
        
        message2print = "{started" + "; get-authkey-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
  
        message2print = "{returning" + "; get-authkey-curren-function-returning-by-get-authkey-current-of-CurrentProcess4Xi: " + str(get_authkey_current_process4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
    
        return get_authkey_current_process4xi()
    #</methodize4xi>
            
    #4#
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-identity-current-of-CurrentProcess4Xi" usage = "initializes the identity of the current process"> 
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def init_identity_current(self, param='Id4XiProcess'):          
        '''
        init_identity_current initializes the identity of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "init_identity_current"
        
        
        message2print = "{started" + "; init-identity-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
        message2print = "{passed" + "; param-passed-to-init-identity-current-of-CurrentProcess4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  

        init_identity_current_process4xi(param)

        message2print = "{returning" + "; init-identity-current-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
    #</methodize4xi>
      
     
    
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-identity-current-of-CurrentProcess4Xi" usage = "sets the identity of the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def set_identity_current(self, param='Id4XiProcess'):          
        '''
        set_identity_current sets the identity of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "set_identity_current"
        
        
        message2print = "{started" + "; set-identity-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
        message2print = "{passed" + "; param-passed-to-set-identity-current-of-CurrentProcess4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  

        set_identity_current_process4xi(param)
        
        message2print = "{returning" + "; set-identity-current-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
    #</methodize4xi>
      
         
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-identity-current-of-CurrentProcess4Xi" usage = "gets the identity info of the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def get_identity_current(self):          
        '''
        get_identity_current gets the identity info of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "get_identity_current"
        
        message2print = "{started" + "; get-identity-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
  
  
        message2print = "{returning" + "; get-identity-current-function-returning-by-get-identity-current-of-CurrentProcess4Xi: " + str(get_identity_current_process4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
  
        return get_identity_current_process4xi()
    #</methodize4xi>
            
    #5#
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-name-current-of-CurrentProcess4Xi" usage = "initializes the name of the current process"> 
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def init_name_current(self, param='Name4XiProcess'):          
        '''
        init_name_current initializes the name of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "init_name_current"
        
        
        message2print = "{started" + "; init-name-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
        message2print = "{passed" + "; param-passed-to-init-name-current-of-CurrentProcess4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  

        init_name_current_process4xi(param)

        message2print = "{returning" + "; init-name-current-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
    #</methodize4xi>
      
     
    
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-name-current-of-CurrentProcess4Xi" usage = "sets the name of the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def set_name_current(self, param='Name4XiProcess'):          
        '''
        set_name_current sets the name of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "set_name_current"
        
        
        message2print = "{started" + "; set-name-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
        message2print = "{passed" + "; param-passed-to-set-name-current-of-CurrentProcess4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  

        set_name_current_process4xi(param)
        
        message2print = "{returning" + "; set-name-current-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
    #</methodize4xi>
      
         
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-name-current-of-CurrentProcess4Xi" usage = "gets the name info of the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def get_name_current(self):          
        '''
        get_name_current gets the name info of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "get_name_current"
        
        message2print = "{started" + "; get-name-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
  
        message2print = "{returning" + "; get-name-current-function-returning-by-get-name-current-of-CurrentProcess4Xi: " + str(get_name_current_process4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
    

        return get_name_current_process4xi()
    #</methodize4xi>
        
    #6#
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-counter-current-of-CurrentProcess4Xi" usage = "initializes the counter of the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def init_counter_current(self, param=1):          
        '''
        init_counter_current initializes the counter of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "init_counter_current"
        
        
        message2print = "{started" + "; init-counter-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
        message2print = "{passed" + "; param-passed-to-init-counter-current-of-CurrentProcess4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  

        init_counter_current_process4xi(param)
    

        message2print = "{returning" + "; init-counter-current-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
    #</methodize4xi>
      
     
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-counter-current-of-CurrentProcess4Xi" usage = "sets the counter of the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def set_counter_current(self, param=1):          
        '''
        set_counter_current sets the counter of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "set_counter_current"
        
        
        message2print = "{started" + "; set-counter-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
        message2print = "{passed" + "; param-passed-to-set-counter-current-of-CurrentProcess4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  

        set_counter_current_process4xi(param)

        message2print = "{returning" + "; set-counter-current-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
    #</methodize4xi>
      
         
        
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-counter-current-of-CurrentProcess4Xi" usage = "gets the counter info of the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def get_counter_current(self):          
        '''
        get_counter_current gets the counter info of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "get_counter_current"
        
        message2print = "{started" + "; get-counter-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
  
  
        message2print = "{returning" + "; get-counter-current-function-returning-by-get-counter-current-of-CurrentProcess4Xi: " + str(get_counter_current_process4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
  
        return get_counter_current_process4xi()                                                                  
    #</methodize4xi>
             
    #7#
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-daemonic-current-of-CurrentProcess4Xi" usage = "initializes the daemonic of the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def init_daemonic_current(self, param='Daemonic4XiProcess'):          
        '''
        init_daemonic_current initializes the daemonic of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "init_daemonic_current"
        
        
        message2print = "{started" + "; init-daemonic-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
        message2print = "{passed" + "; param-passed-to-init-daemonic-current-of-CurrentProcess4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  

        init_daemonic_current_process4xi(param)

        message2print = "{returning" + "; init-daemonic-curren-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
    #</methodize4xi>
      
     
    
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-daemonic-current-of-CurrentProcess4Xi" usage = "sets the daemonic of the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def set_daemonic_current(self, param='Daemonic4XiProcess'):          
        '''
        set_daemonic_current sets the daemonic of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "set_daemonic_current"
        
        message2print = "{started" + "; set-daemonic-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
        message2print = "{passed" + "; param-passed-to-set-daemonic-current-of-CurrentProcess4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  

        set_daemonic_current_process4xi(param)
        
        message2print = "{returning" + "; set-daemonic-current-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
    #</methodize4xi>
      
         
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-daemonic-current-of-CurrentProcess4Xi" usage = "gets the daemonic info of the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def get_daemonic_current(self):          
        '''
        get_daemonic_current gets the daemonic info of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "get_daemonic_current"
        
        message2print = "{started" + "; get-daemonic-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
  
  
        message2print = "{returning" + "; get-daemonic-current-function-returning-by-get-daemonic-current-of-CurrentProcess4Xi: " + str(get_daemonic_current_process4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
  
        return get_daemonic_current_process4xi() 
    #</methodize4xi>
       
    #8#
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-tempdir-current-of-CurrentProcess4Xi" usage = "initializes the tempdir of the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def init_tempdir_current(self, param=None):          
        '''
        init_tempdir_current initializes the tempdir of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "init_tempdir_current"
        
        
        message2print = "{started" + "; init-tempdir-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
        message2print = "{passed" + "; param-passed-to-init-tempdir-current-of-CurrentProcess4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  

        init_tempdir_current_process4xi(param)
    

        message2print = "{returning" + "; init-tempdir-current-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
    #</methodize4xi>
       
     
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-tempdir-current-of-CurrentProcess4Xi" usage = "sets the tempdir of the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def set_tempdir_current(self, param=None):          
        '''
        set_tempdir_current sets the tempdir of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "set_tempdir_current"
        
        
        message2print = "{started" + "; set-tempdir-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
        message2print = "{passed" + "; param-passed-to-set-tempdir-current-of-CurrentProcess4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  

        set_tempdir_current_process4xi(param)

        message2print = "{returning" + "; set-tempdir-current-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
    #</methodize4xi>
       
         
        
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-tempdir-current-of-CurrentProcess4Xi" usage = "gets the tempdir info of the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def get_tempdir_current(self):          
        '''
        get_tempdir_current gets the tempdir info of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "get_tempdir_current"
        
        message2print = "{started" + "; get-tempdir-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
  
  
        message2print = "{returning" + "; get-tempdir-current-function-returning-by-get-tempdir-current-of-CurrentProcess4Xi: " + str(get_tempdir_current_process4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
  
        return get_tempdir_current_process4xi()
    #</methodize4xi>
            
    #9#
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "add-child-current-of-CurrentProcess4Xi" usage = "adds a child to the current process"> 
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def add_child_current(self, param):          
        '''
        add_child_current adds a child to the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "add_child_current"
        
        
        message2print = "{started" + "; add-child-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
        message2print = "{passed" + "; param-passed-to-add-child-current-of-CurrentProcess4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  

        add_child_current_process4xi(param)

        message2print = "{returning" + "; add-child-current-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
    #</methodize4xi>
         
     
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "discard-child-current-of-CurrentProcess4Xi" usage = "discards a child to the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def discard_child_current(self, param):          
        '''
        discard_child_current discards a child to the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "discard_child_current"
        
        
        message2print = "{started" + "; discard-child-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
        message2print = "{passed" + "; param-passed-to-discard-child-current-of-CurrentProcess4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  

        # { discard_child_current_process4xi : discard_child_current_process4xi ; returning after having _current_process._children set to:
        #  {<Process4Xi(SyncManager4Xi-2, stopped)>};time: 11:22:39 07/03/09 FLE Daylight Time}
        
        discard_child_current_process4xi(param)

        message2print = "{returning" + "; discard-child-curren-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
    #</methodize4xi>
         
                                        
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-children-current-of-CurrentProcess4Xi" usage = "returns the list of the current process children">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def get_children_current(self):          
        '''
        get_children_current returns the list of the current process children
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "get_children_current"
        
        message2print = "{started" + "; get-children-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
  
  
        message2print = "{returning" + "; get-children-current-function-returning-by-get-children-current-of-CurrentProcess4Xi: " + str(get_children_current_process4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
  
        return get_children_current_process4xi()        
    #</methodize4xi>
            
    #10#
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-manager-server-current-of-CurrentProcess4Xi" usage = "initializes the manager_server of the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def init_manager_server_current(self, param):          
        '''
        init_manager_server_current initializes the manager_server of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "init_manager_server_current"
        
        
        message2print = "{started" + "; init-manager-server-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
        message2print = "{passed" + "; param-passed-to-init-manager-server-current-of-CurrentProcess4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  

        init_manager_server_current_process4xi(param)
    
        message2print = "{returning" + "; init-manager-server-current-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
    #</methodize4xi>
      
     
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-manager-server-current-of-CurrentProcess4Xi" usage = "sets the manager_server of the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def set_manager_server_current(self, param):          
        '''
        set_manager_server_current sets the manager_server of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "set_manager_server_current"
        
        
        message2print = "{started" + "; set-manager-server-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
        
        message2print = "{passed" + "; param-passed-to-set-manager-server-current-of-CurrentProcess4Xi: " + str(param) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
  

        set_manager_server_current_process4xi(param)

        message2print = "{returning" + "; set-manager-server-current-of-CurrentProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)         
    #</methodize4xi>
             
        
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-manager-server-current-of-CurrentProcess4Xi" usage = "gets the manager_server info of the current process">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------    
    def get_manager_server_current(self):          
        '''
        get_manager_server_current gets the manager_server info of the current process
        '''
        class2print = "CurrentProcess4Xi"
        method2print = "get_manager_server_current"
        
        
        message2print = "{started" + "; get-manager-server-current-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
  
        message2print = "{returning" + "; get-manager-server-current-process4xi-function-returning-by-get-manager-server-current-of-CurrentProcess4Xi: " + str(get_manager_server_current_process4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        
        return get_manager_server_current_process4xi()                     
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-CurrentProcess4Xi" usage = "senses class objects">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        senses CurrentProcess4Xi class objects
        '''
        
        class2print = 'CurrentProcess4Xi'
        method2print = 'sense'
        
        
        message2print = "{started" + "; sense-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
  
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; CurrentProcess4Xi-sensing-by-sense-of-CurrentProcess4Xi: " + str(CurrentProcess4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-CurrentProcess4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['inheritance-of-currentprocess2xi'] = object
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-CurrentProcess4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
        message2print = "{sensed" + "; CurrentProcess4Xi-sensed-by-sense-of-CurrentProcess4Xi: " + str(CurrentProcess4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-CurrentProcess4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)          
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-CurrentProcess4Xi" usage = "reasons class objects">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        reasons CurrentProcess4Xi class objects
        '''
                 
        
        class2print = 'CurrentProcess4Xi'
        method2print = 'reason'

        
        message2print = "{started" + "; reason-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
    
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; CurrentProcess4Xi-reasoning-by-reason-of-CurrentProcess4Xi: "  + str(CurrentProcess4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-CurrentProcess4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
          
        
        message2print = "{reasoned" + "; CurrentProcess4Xi-reasoned-by-reason-of-CurrentProcess4Xi: "  + str(CurrentProcess4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-CurrentProcess4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)            
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-CurrentProcess4Xi" usage = "aces class objects">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        aces CurrentProcess4Xi class objects 
        '''
               
        
        
        class2print = 'CurrentProcess4Xi'
        method2print = 'ace'
        
        
        message2print = "{started" + "; ace-of-CurrentProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
            
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; CurrentProcess4Xi-acing-by-ace-of-CurrentProcess4Xi: " + "CurrentProcess4Xi" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-CurrentProcess4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; CurrentProcess4Xi-aced-by-ace-of-CurrentProcess4Xi: " + "CurrentProcess4Xi" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-CurrentProcess4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)             
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi> 

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_current_process4xi.txt
#   sense-test-current-process4xi.xml
#   reason-test-current-process4xi.xml
#   ace-test-current-process4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

    
    

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of current_process4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>


